# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in /Users/mengcuiguang/Documents/softwareDevelopment/android-sdk-macosx/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

    #指定代码的压缩级别
    -optimizationpasses 5

    #包明不混合大小写
    -dontusemixedcaseclassnames

    #不去忽略非公共的库类
    -dontskipnonpubliclibraryclasses

     #优化  不优化输入的类文件
    -dontoptimize

     #预校验
    -dontpreverify

     #混淆时是否记录日志
    -verbose

     # 混淆时所采用的算法
    -optimizations !code/simplification/arithmetic,!field/*,!class/merging/*

    #保护注解
    -keepattributes *Annotation*

    #保护内部类 保护反射
    -keepattributes Exceptions, Signature, InnerClasses ,EnclosingMethod

    # 保持哪些类不被混淆
    -keep public class * extends android.app.Fragment
    -keep public class * extends android.app.Activity
    -keep public class * extends android.app.Application
    -keep public class * extends android.app.Service
    -keep public class * extends android.data.BroadcastReceiver
    -keep public class * extends android.data.ContentProvider
    -keep public class * extends android.app.backup.BackupAgentHelper
    -keep public class * extends android.preference.Preference
    -keep public class com.android.vending.licensing.ILicensingService
    #如果有引用v4包可以添加下面这行
    -keep public class * extends android.support.v4.app.Fragment

    #忽略警告
    -ignorewarnings

    ##记录生成的日志数据,gradle build时在本项目根目录输出##

    #apk 包内所有 class 的内部结构
    -dump class_files.txt
    #未混淆的类和成员
    -printseeds seeds.txt
    #列出从 apk 中删除的代码
    -printusage unused.txt
    #混淆前后的映射
    -printmapping mapping.txt

    ########记录生成的日志数据，gradle build时 在本项目根目录输出-end######

    # ===================== 混淆保护自己项目的部分代码以及引用的第三方jar包library ================

    #okhttp
    -dontwarn com.squareup.okhttp.**
    -keep class com.squareup.okhttp.** { *;}
    -dontwarn okio.**

    #butterknife
    -keep class butterknife.** { *; }
    -dontwarn butterknife.internal.**
    -keep class **$$ViewBinder { *; }

    -keepclasseswithmembernames class * {
        @butterknife.* <fields>;
    }

    -keepclasseswithmembernames class * {
        @butterknife.* <methods>;
    }

    #忽略警告
    -dontwarn retrofit.**
    #保留一个完整的包
    -keep class retrofit.** {
        *;
    }


    #忽略警告
    -dontwarn rx.internal.util.unsafe.**
    #保留一个完整的包
    -keep class rx.internal.util.unsafe.** {
        *;
    }

    #忽略警告
    -dontwarn uk.co.senab.photoview.**
    #保留一个完整的包
    -keep class uk.co.senab.photoview.** {
          *;
    }


    #忽略警告
    -dontwarn rx.internal.util.unsafe.**
    #保留一个完整的包
    -keep class rx.internal.util.unsafe.** {
        *;
     }


    #忽略警告
    -dontwarn com.mints.goodmoney.mvp.model.**
    #保留实体类
    -keep class com.mints.goodmoney.mvp.model.** {
        *;
    }

    #忽略警告
    -dontwarn com.mints.goodmoney.ui.widgets.**
    #保留实体类
    -keep class com.mints.goodmoney.ui.widgets.** {
        *;
    }

    #系统的design 忽略警告
    -dontwarn android.support.design.widget.**
    #保留实体类
    -keep class android.support.design.widget.** {
        *;
    }

    #系统的renderscript 忽略警告
    -dontwarn android.support.v8.renderscript.**
    #保留实体类
    -keep class android.support.v8.renderscript.** {
         *;
     }


    #忽略警告
    -dontwarn cn.com.library.rxbus.**
    #保留实体类
    -keep class cn.com.library.rxbus.** {*;}

    #忽略警告  /高德
    -dontwarn com.amap.api.**
    -dontwarn com.autonavi.aps.amapapi.model.**
    -dontwarn com.loc.**
    #保留一个完整的包
    -keep class com.amap.api.** {*;}
    -keep class com.autonavi.aps.amapapi.model.** {*;}
    -keep class com.loc.** {*;}

    #忽略警告
    -dontwarn cn.fraudmetrix.sdk.**
    #保留一个完整的包
    -keep class cn.fraudmetrix.sdk.** {
         *;
    }

    #忽略警告
    -dontwarn com.nineoldandroids.**
    #保留一个完整的包
    -keep class com.nineoldandroids.** {
         *;
    }

    #忽略警告
    -dontwarn Decoder.**
    #保留一个完整的包
    -keep class Decoder.** {
         *;
    }

    #忽略警告
    -dontwarn com.nostra13.universalimageloader.**
    #保留实体类
    -keep class com.nostra13.universalimageloader.** {
         *;
    }

    #忽略警告
    -dontwarn com.megvii.**
    #保留实体类
    -keep class com.megvii.** { *; }

    -dontwarn cn.jpush.**
    -keep class cn.jpush.** { *; }

    #如果引用了v4或者v7包
    -dontwarn android.support.**


    #如果用用到Gson解析包的，直接添加下面这几行就能成功混淆，不然会报错。
    #gson
    -keepattributes Signature
    # Gson specific classes
    -keep class sun.misc.Unsafe { *; }
    # Application classes that will be serialized/deserialized over Gson
    -keep class com.google.gson.examples.android.model.** { *; }

# ===================== 混淆保护自己项目的部分代码以及引用的第三方jar包library-end ================

    -keep public class * extends android.view.View {
        public <init>(android.data.Context);
        public <init>(android.data.Context, android.util.AttributeSet);
        public <init>(android.data.Context, android.util.AttributeSet, int);
        public void set*(...);
    }

    #保持 native 方法不被混淆
    -keepclasseswithmembernames class * {
        native <methods>;
    }

    #保持自定义控件类不被混淆
    -keepclasseswithmembers class * {
        public <init>(android.data.Context, android.util.AttributeSet);
    }

    #保持自定义控件类不被混淆
    -keepclassmembers class * extends android.app.Activity {
       public void *(android.view.View);
    }

    #保持 Parcelable 不被混淆
    -keep class * implements android.os.Parcelable {
      public static final android.os.Parcelable$Creator *;
    }

    #保持 Serializable 不被混淆
    -keepnames class * implements java.io.Serializable

    #保持 Serializable 不被混淆并且enum 类也不被混淆
    -keepclassmembers class * implements java.io.Serializable {
        static final long serialVersionUID;
        private static final java.io.ObjectStreamField[] serialPersistentFields;
        !static !transient <fields>;
        !private <fields>;
        !private <methods>;
        private void writeObject(java.io.ObjectOutputStream);
        private void readObject(java.io.ObjectInputStream);
        java.lang.Object writeReplace();
        java.lang.Object readResolve();
    }

    #保持枚举 enum 类不被混淆 如果混淆报错，建议直接使用上面的 -keepclassmembers class * implements java.io.Serializable即可
    -keepclassmembers enum * {
      public static **[] values();
      public static ** valueOf(java.lang.String);
    }

    -keepclassmembers class * {
        public void *ButtonClicked(android.view.View);
    }

    #不混淆资源类
    -keepclassmembers class **.R$* {
        public static <fields>;
    }

    # 避免影响升级功能，需要keep住support包的类
    -keep class android.support.**{*;}



    # ===================== shareSDK START ================
    -dontwarn com.mob.**
    -dontwarn cn.sharesdk.**
    -dontwarn **.R$*

    -keep class cn.sharesdk.**{*;}
    -keep class com.sina.**{*;}
    -keep class **.R$* {*;}
    -keep class **.R{*;}

    -keep class com.mob.**{*;}
    # ======================= shareSDK END ===============




    # ===================== umeng START ================
    -keep class com.umeng.** {*;}

    -keepclassmembers class * {
       public <init> (org.json.JSONObject);
    }

    -keepclassmembers enum * {
        public static **[] values();
        public static ** valueOf(java.lang.String);
    }
    # ======================= umeng END ================



    # ===================== 穿山甲 START ================
    -keep class com.bytedance.sdk.openadsdk.** { *; }
    -keep public interface com.bytedance.sdk.openadsdk.downloadnew.** {*;}
    -keep class com.pgl.sys.ces.* {*;}
    # ======================= 穿山甲 END ================



    # ===================== TalkingData START ================
    -dontwarn com.tendcloud.tenddata.**
    -keep class com.tendcloud.** {*;}
    -keep public class com.tendcloud.tenddata.** { public protected *;}
    -keepclassmembers class com.tendcloud.tenddata.**{
     public void *(***);
     }
    -keep class com.talkingdata.sdk.TalkingDataSDK {public *;}
    -keep class com.apptalkingdata.** {*;}
    -keep class dice.** {*; }
    -dontwarn dice.**
    # ======================= TalkingData END ================




    # ===================== 极光推送 START ================
        -keep class * extends cn.jpush.android.helpers.JPushMessageReceiver { *; }

        # ===================== 极光一键登录 ================
        -dontoptimize
        -dontpreverify
        -dontwarn cn.jpush.**
        -keep class cn.jpush.** { *; }
        -dontwarn cn.jiguang.**
        -keep class cn.jiguang.** { *; }
        -dontwarn com.cmic.**
        -keep class com.cmic.** { *; }
        -dontwarn com.unicom.**
        -keep class com.unicom.** { *; }
        -dontwarn cn.com.chinatelecom.**
        -keep class cn.com.chinatelecom.** { *; }
    # ======================= 极光推送 END ================



    # ===================== 数美 START ================
    -keep class com.ishumei.** { *; }
    # ======================= 数美 END ================


    # ===================== 猎豹游戏 START ================
    -keep class com.cmgame.x5fit.** {*;}
    -keep class com.cmgame.gdtfit.** {*;}
    -keep class com.cmcm.cmgame.** {*;}
    # ======================= 猎豹游戏 END ================




    # ===================== 移动安全联盟 START ================
    -keep class com.bun.miitmdid.core.** {*;}
    # ======================= 移动安全联盟 END ================




    # ===================== 一览视频 START ================
    -keep class com.yilan.sdk.**{
        *;
    }
    -dontwarn javax.annotation.**
    -dontwarn sun.misc.Unsafe
    -dontwarn org.conscrypt.*
    -dontwarn okio.**
    ###阿里云混淆
    -keep class com.alibaba.sdk.android.**{*;}
    -keep class com.ut.**{*;}
    -keep class com.ta.**{*;}

    ###其他混淆
    -keep class android.support.v4.**{
        public *;
    }
    -keep class android.support.v7.**{
        public *;
    }

    -keep class org.chromium.** {*;}
    -keep class org.chromium.** { *; }
    -keep class aegon.chrome.** { *; }
    -keep class com.kwai.**{ *; }
    -dontwarn com.kwai.**
    -dontwarn com.kwad.**
    -dontwarn com.ksad.**
    -dontwarn aegon.chrome.**

    -keepclassmembers class * extends android.app.Activity { public void *(android.view.View);
    }
    -keepclassmembers enum * {
    public static **[] values();
    public static ** valueOf(java.lang.String);
    }
    -keep class com.baidu.mobads.*.** { *; }

    #ijkplayer
    -keep class tv.danmaku.ijk.media.player.** {*;}
    -keep class tv.danmaku.ijk.media.player.IjkMediaPlayer{*;}
    -keep class tv.danmaku.ijk.media.player.ffmpeg.FFmpegApi{*;}



    # ======================= 一览视频 END ================








    # ===================== 变现猫 START ================
    -keep class com.ss.android.* {*;}
    -keep class com.pgl.* {*;}

    -keep class com.qq.e.** {
     public protected *;
    }

    -keep class com.wgs.sdk.**{ *;}
    -keep class com.dhcw.sdk.**{*;}

    -keep class android.support.v4.app.NotificationCompat**{
     public *;
    }
    # ======================= 变现猫 END ================





    # ===================== 闪电盒子 START ================
    -keep class com.wannuosili.sdk.** {*;}
    -dontwarn com.wannuosili.sdk.**
    # ======================= 闪电盒子 END ================




    # ===================== 瑞狮新闻 START ================
    -keep class com.xr.xrsdk.** { *;}
    -keep class com.xr.sharesdk.** { *;}
    -keep class com.tencent.** {*;}
    -keep class com.qq.e.** {public protected *;}
    -keepclassmembers class * extends android.app.Activity {
       public void *(android.view.View);
    }
    -keepclassmembers enum * {
        public static **[] values();
        public static ** valueOf(java.lang.String);
    }
    -keep class com.baidu.mobads.** { *; }
    -keep class com.baidu.mobad.** { *; }
    -keep class com.bun.miitmdid.core.** {*;}
    # WindAd
    -keep class sun.misc.Unsafe { *; }
    -dontwarn com.sigmob.**
    -keep class com.sigmob.**.**{*;}
    # ======================= 瑞狮新闻 END ================




    # ===================== 聚乐云 START ================
    -keep class com.lzy.okgo.** {*;}
    -keep class com.fly.scenemodule.** {*;}

    #GSON
    -keep class com.google.gson.** {*;}
    -keep class com.google.**{*;}
    -keep class sun.misc.Unsafe { *; }
    -keep class com.google.gson.stream.** { *; }
    -keep class com.google.gson.examples.android.model.** { *; }

    #agentweb
    -keep class com.just.agentweb.** {
        *;
    }
    -dontwarn com.just.agentweb.**

    #http3
    #-------------- okhttp3 start-------------
    # OkHttp3

    -keepattributes Signature
    -keepattributes *Annotation*
    -keep class com.squareup.okhttp.* { *; }
    -keep interface com.squareup.okhttp.** { *; }
    -dontwarn com.squareup.okhttp.**

    # okhttp 3
    -keepattributes Signature
    -keepattributes *Annotation*
    -keep class okhttp3.** { *; }
    -keep interface okhttp3.** { *; }
    -dontwarn okhttp3.**

    # Okio
    -dontwarn com.squareup.**
    -dontwarn okio.**
    -keep class  okio.* { *; }
    -keep public class org.codehaus.* { *; }
    -keep public class java.nio.* { *; }

    # ======================= 聚乐云 END ================




    # ===================== 喜马拉雅 START ================
    -dontwarn com.google.gson.**
    -dontwarn android.support.**
    -keep class android.support.** { *;}
    -dontwarn com.ximalaya.ting.android.player.**
    -keep class com.ximalaya.ting.android.player.** { *;}
    -dontwarn com.ximalaya.ting.android.opensdk.**
    -keep interface com.ximalaya.ting.android.opensdk.** {*;}
    -keep class com.ximalaya.ting.android.opensdk.** { *; }
    # ======================= 喜马拉雅 END ================





    # ===================== 微转分享 START ================
    -keep class com.xiangzi.*{*;}
    -dontwarn com.xiangzi.**
    # x5浏览器混淆需要加
    -dontwarn com.tencent.smtt.export.external.**
    -keep class com.tencent.smtt.export.external.**{*;}
    -keep class com.tencent.tbs.video.interfaces.IUserStateChangedListener {*;}
    -keep class com.tencent.smtt.sdk.CacheManager {*;}
    -keep class com.tencent.smtt.sdk.CookieManager {*;}
    -keep class com.tencent.smtt.sdk.WebHistoryItem {*;}
    -keep class com.tencent.smtt.sdk.WebViewDatabase {*;}
    -keep class com.tencent.smtt.sdk.WebBackForwardList {*;}
    -keep public class com.tencent.smtt.sdk.WebView {*;}
    -keep public class com.tencent.smtt.sdk.WebView$HitTestResult{*;}
    -keep public class com.tencent.smtt.sdk.WebView$WebViewTransport {*;}
    -keep public class com.tencent.smtt.sdk.WebView$PictureListener {*;}
    -keepattributes InnerClasses
    -keep public enum com.tencent.smtt.sdk.WebSettings$** {*;}
    -keep public enum com.tencent.smtt.sdk.QbSdk$** {*;}
    -keep public class com.tencent.smtt.sdk.WebSettings {*;}
    -keep public class com.tencent.smtt.sdk.ValueCallback{*;}
    -keep public class com.tencent.smtt.sdk.WebViewClient {*;}
    -keep public class com.tencent.smtt.sdk.DownloadListener {*;}
    -keep public class com.tencent.smtt.sdk.WebChromeClient {*;}
    -keep public class com.tencent.smtt.sdk.WebChromeClient$FileChooserParams {*;}
    -keep class com.tencent.smtt.sdk.SystemWebChromeClient{*;}
    # 1. extension interfaces should be apparent
    -keep public class com.tencent.smtt.export.external.extension.interfaces.* {*;}
    # 2. interfaces should be apparent
    -keep public class com.tencent.smtt.export.external.interfaces.* {*;}
    -keep public class com.tencent.smtt.sdk.WebViewCallbackClient {*;}
    -keep public class com.tencent.smtt.sdk.WebStorage$QuotaUpdater {*;}
    -keep public class com.tencent.smtt.sdk.WebIconDatabase {*;}
    -keep public class com.tencent.smtt.sdk.WebStorage {*;}
    -keep public class com.tencent.smtt.sdk.DownloadListener {*;}
    -keep public class com.tencent.smtt.sdk.QbSdk {*;}
    -keep public class com.tencent.smtt.sdk.QbSdk$PreInitCallback {*;}
    -keep public class com.tencent.smtt.sdk.CookieSyncManager {*;}
    -keep public class com.tencent.smtt.sdk.Tbs* {*;}
    -keep public class com.tencent.smtt.utils.LogFileUtils {*;}
    -keep public class com.tencent.smtt.utils.TbsLog {*;}
    -keep public class com.tencent.smtt.utils.TbsLogClient {*;}
    -keep public class com.tencent.smtt.sdk.CookieSyncManager {*;}
    # Added for game demos
    -keep public class com.tencent.smtt.sdk.TBSGamePlayer {*;}
    -keep public class com.tencent.smtt.sdk.TBSGamePlayerClient* {*;}
    -keep public class com.tencent.smtt.sdk.TBSGamePlayerClientExtension {*;}
    -keep public class com.tencent.smtt.sdk.TBSGamePlayerService* {*;}
    -keep public class com.tencent.smtt.utils.Apn {*;}
    -keep class com.tencent.smtt.** {*;}
    # end
    -keep public class com.tencent.smtt.export.external.extension.proxy.ProxyWebViewClientExtension {*;}
    -keep class MTT.ThirdAppInfoNew {*;}
    -keep class com.tencent.mtt.MttTraceEvent {*;}
    # Game related
    -keep public class com.tencent.smtt.gamesdk.* {*;}
    -keep public class com.tencent.smtt.sdk.TBSGameBooter {*;}
    -keep public class com.tencent.smtt.sdk.TBSGameBaseActivity {*;}
    -keep public class com.tencent.smtt.sdk.TBSGameBaseActivityProxy {*;}
    -keep public class com.tencent.smtt.gamesdk.internal.TBSGameServiceClient {*;}
    # webView处理，项目中没有使用到webView忽略即可,webview与JS交互内部类不能混淆
    -keepclassmembers class com.show.you.WebVerfiedActivity$MyHandler {*;}
    -keepattributes *JavascriptInterface*

    -keep public class com.mints.goodmoney.ui.fragment.WzFragment.JsObject.**
    # ======================= 微转分享 END ================





    # ===================== OAID START ================
    -keep class XI.CA.XI.**{*;}
    -keep class XI.K0.XI.**{*;}
    -keep class XI.XI.K0.**{*;}
    -keep class XI.vs.K0.**{*;}
    -keep class XI.xo.XI.XI.**{*;}
    -keep class com.asus.msa.SupplementaryDID.**{*;}
    -keep class com.asus.msa.sdid.**{*;}
    -keep class com.bun.lib.**{*;}
    -keep class com.bun.miitmdid.**{*;}
    -keep class com.huawei.hms.ads.identifier.**{*;}
    -keep class com.samsung.android.deviceidservice.**{*;}
    -keep class org.json.**{*;}
    -keep public class com.netease.nis.sdkwrapper.Utils {public <methods>;}
    # ======================= OAID END ================




    # ===================== 快手 START ================ 好兔视频已混淆
#    -keep class org.chromium.** {*;}
#    -keep class org.chromium.** { *; }
#    -keep class aegon.chrome.** { *; }
#    -keep class com.kwai.**{ *; }
#    -dontwarn com.kwai.**
#    -dontwarn com.kwad.**
#    -dontwarn com.ksad.**
#    -dontwarn aegon.chrome.**
    # ======================= 快手 END ================






    # =====================  蘑菇星球 START ================
    -keep class com.fendasz.moku.planet.** { *; }
    -keep class com.fendasz.moku.liulishuo.okdownload.** { *; }
    -keep class com.bun.miitmdid.core.** {*;}
    -keep class com.google.android.material.** {*;}
    -keep class android.support.design.** {*;}
    -keep class androidx.swiperefreshlayout.widget.** {*;}
    -keep class android.support.v4.widget.** {*;}

    ##Glide
    -dontwarn com.bumptech.glide.**
    -keep class com.bumptech.glide.**{*;}
    -keep public class * implements com.bumptech.glide.module.GlideModule
    -keep public class * extends com.bumptech.glide.AppGlideModule
    -keep public enum com.bumptech.glide.load.resource.bitmap.ImageHeaderParser$** {
      **[] $VALUES;
      public *;
    }
    # ======================= 蘑菇星球 END ================







    # =====================  听读 START ================
    -keep class com.chineseall.reader17ksdk.**{*;}
    -keep class com.chineseall.reader.utils.**{*;}
    -keep class com.chineseall.reader.lib.reader.**{*;}
    #arouter
    -keep public class com.alibaba.android.arouter.routes.**{*;}
    -keep public class com.alibaba.android.arouter.facade.**{*;}
    -keep class * implements
    com.alibaba.android.arouter.facade.template.ISyringe{*;}
    # If you use the byType method to obtain Service, add the
    -keep interface * implements
    com.alibaba.android.arouter.facade.template.IProvider
    #百度语音
    -keep class com.baidu.tts.**{*;}
    -keep class com.baidu.speechsynthesizer.**{*;}
    #eventBus
    -keepattributes *Annotation*
    -keepclassmembers class ** {
        @org.greenrobot.eventbus.Subscribe <methods>;
    }
    -keep enum org.greenrobot.eventbus.ThreadMode { *; }
    -keep class org.greenrobot.eventbug.**{*;}
    -keepclassmembers class * extends
    org.greenrobot.eventbus.util.ThrowableFailureEvent {
        <init>(java.lang.Throwable);
    }
    #rxjava
    -dontwarn rx.**
    -keep class rx.** { *; }
      #okhttp3
    -dontwarn com.squareup.okhttp3.**
    -keep class com.squareup.okhttp3.** { *;}
    -keep class okhttp3.** { *;}
    -keep class okio.** { *;}
    -dontwarn sun.security.**
    -keep class sun.security.** { *;}
    -dontwarn okio.**
    -dontwarn okhttp3.**
    #retrofit2
    -dontwarn retrofit2.**
    -keep class retrofit2.** { *; }
    -keepattributes Signature
    -keepattributes Exceptions
    -dontwarn org.robovm.**
    -keep class org.robovm.** { *; }
    #glide
    -keep public class * implements
    com.bumptech.glide.module.GlideModule
    -keep public enum
    com.bumptech.glide.load.resource.bitmap.ImageHeaderParser$** {
      **[] $VALUES;
    public *; }
    -keep class com.bumptech.glide.** { *; }
    #gson
    -keep class com.google.gson.** {*;}
    #-keep class com.google.**{*;}
    -keep class sun.misc.Unsafe { *; }
    -keep class com.google.gson.stream.** { *; }

      -keep class com.google.gson.examples.android.model.** { *; }
    -keep class com.google.** {
    <fields>;
    <methods>; }
    -keepclassmembers class * implements java.io.Serializable {
        static final long serialVersionUID;
        private static final java.io.ObjectStreamField[]
    serialPersistentFields;
        private void writeObject(java.io.ObjectOutputStream);
        private void readObject(java.io.ObjectInputStream);
        java.lang.Object writeReplace();
        java.lang.Object readResolve();
    }
    -dontwarn com.google.gson.**
    #umeng
    -dontwarn com.umeng.**
    -keep class com.umeng.**{*;}
    -keep class u.aly.**{*;}
    -keep class com.google.**{*;}
    #filter
    -keep class com.baiiu.filter.**{*;}
    #dragger
    -keep class dagger.** { *; }
    #statuslayout
    -keep class com.f1reking.**{*;}
    #dp
    -keep class com.pdog.dimension.**{*;}
    #seekbar
    -keep class com.warkiz.widget.**{*;}

    #banner
    -keep class com.zhpan.bannerview.**{*;}
    -keep class com.zhpan.indicator.**{*;}
    #refresh
    -keep class com.scwang.smart.refresh.**{*;}
    #skin
    -keep class skin.support.**{*;}
    #神策
    -dontwarn com.sensorsdata.analytics.android.sdk.** -keep class com.sensorsdata.analytics.android.sdk.** { *;
    }
    -dontwarn com.sensorsdata.analytics.android.**
    -keep class com.sensorsdata.analytics.android.** {
    *;
    }
    # 使用可视化埋点需添加
    -keep class **.R$* {
    <fields>; }
    # ======================= 听读 END ================



    # ======================= 愉悦赚 START ================
    -dontwarn com.tencent.**
    #-- 微信sdk--
    -keep class com.tencent.** {
      *;
    }
    -keep class android.support.v4.** { *; }
    -keep class android.support.v7.** { *; }
    -keep class com.bun.miitmdid.core.** {*;}
    -keep class com.mdad.sdk.mduisdk.AsoWebViewActivity {
       public <methods>;
    }
    -keep class com.mdad.sdk.mduisdk.shouguan.** { *; }
    # ======================= 愉悦赚 END ================

    # ======================= 芒果 START ================
    # ======================= 芒果 END ================