package com.mints.goodmoney.ad.express;

import android.util.DisplayMetrics;
import android.widget.FrameLayout;

import com.mints.goodmoney.MintsApplication;
import com.mints.goodmoney.manager.TTNativeExpressManager;
import com.mints.goodmoney.manager.TtCsjAdManager;

public class TTPreLoadExpressManager {

    private static TTPreLoadExpressManager _inst;

    private TTNativeExpressManager ttNativeExpressManager;

    public static TTPreLoadExpressManager getInstance() {
        if (_inst == null) {
            _inst = new TTPreLoadExpressManager();
        }
        return _inst;
    }

    private void init() {
        ttNativeExpressManager = new TTNativeExpressManager();
        ttNativeExpressManager.initTTAd(false);
    }

    public void onDestroy() {
        if (ttNativeExpressManager != null) {
            ttNativeExpressManager.onTTAdDestroy();
            ttNativeExpressManager = null;
        }
    }

    private TTADLoadSuccessListener mADLoadSuccessListener;

    public void setListener(TTADLoadSuccessListener adLoadSuccessListener) {
        mADLoadSuccessListener = adLoadSuccessListener;
    }

    private float getViewWidth() {
        DisplayMetrics displayMetrics = MintsApplication.getContext().getResources().getDisplayMetrics();
        float density = displayMetrics.density;
        float pxWidth = displayMetrics.widthPixels - (50 * density + 0.5f);
        float dpWidth = pxWidth / density + 0.5f;
        return dpWidth;
    }

    /**
     * 预加载 信息流
     */
    public void loadTtFrameLayout(FrameLayout adFrameLayout) {
        init();

        try {


            ttNativeExpressManager.getNativeExpressInit(TtCsjAdManager.TT_AD_NATIVEEXPRESS_AWARD, adFrameLayout, getViewWidth(), 0);
            ttNativeExpressManager.setTTNativeExpressManagerListener(view -> {
                try {
                    if (view != null) {
                        if (mADLoadSuccessListener != null) {
                            mADLoadSuccessListener.onTTAdLoadSuc(view);
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            });

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
