package com.mints.goodmoney.ad.express;

import android.content.Context;
import android.widget.FrameLayout;

import com.mints.goodmoney.MintsApplication;
import com.mints.goodmoney.common.AppConfig;
import com.mints.goodmoney.manager.TTNativeExpressManager;
import com.mints.goodmoney.manager.TtCsjAdManager;
import com.mints.goodmoney.utils.LogUtil;

/**
 * 喜马拉雅信息流
 */
public class TTPreLoadExpressXmlyManager {

    private static TTPreLoadExpressXmlyManager _inst;

    private FrameLayout ttFrameLayout;
    private TTNativeExpressManager ttNativeExpressManager;

    public static TTPreLoadExpressXmlyManager getInstance() {
        if (_inst == null) {
            _inst = new TTPreLoadExpressXmlyManager();
        }
        return _inst;
    }

    private TTPreLoadExpressXmlyManager() {
//        init();
    }

    private void init() {
        ttNativeExpressManager = new TTNativeExpressManager();
        ttNativeExpressManager.initTTAd(false);
    }

    public void onDestroy() {
        ttNativeExpressManager.onTTAdDestroy();
        ttNativeExpressManager = null;
        AppConfig.xmlyAdFlag = false;
    }

    public FrameLayout getTtFrameLayout() {
        return ttFrameLayout;
    }

    /**
     * 预加载 信息流
     */
    public void loadTtFrameLayout() {
        if (AppConfig.xmlyAdFlag) {
            return;
        }

        init();

        Context context = MintsApplication.getContext();
        ttFrameLayout = null;
        try {
            ttFrameLayout = new FrameLayout(context);
            ttNativeExpressManager.getNativeExpressInit(TtCsjAdManager.TT_AD_NATIVEEXPRESS_XMLY, ttFrameLayout, 360, 0);
            ttNativeExpressManager.setTTNativeExpressManagerListener(view -> {
                if (view == null) {
                    ttFrameLayout = null;
                    AppConfig.xmlyAdFlag = false;
                    LogUtil.d("TTPreLoadExpressXmlyManager",AppConfig.xmlyAdFlag+"");
                } else {

                    try {
                        ttFrameLayout = view;
                        AppConfig.xmlyAdFlag = true;
                        LogUtil.d("TTPreLoadExpressXmlyManager",AppConfig.xmlyAdFlag+"");
                    } catch (Exception e) {
                        e.printStackTrace();
                        ttFrameLayout = null;
                        AppConfig.xmlyAdFlag = false;
                        LogUtil.d("TTPreLoadExpressXmlyManager",AppConfig.xmlyAdFlag+"");
                    }
                }
            });

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
