package com.mints.goodmoney.ad.video;

import android.app.Activity;
import android.os.SystemClock;

import com.mints.goodmoney.ad.video.base.BaseVideoAd;
import com.mints.goodmoney.ad.video.base.VideoAdStatusListener;
import com.mints.goodmoney.common.AppConfig;
import com.mints.goodmoney.common.Constant;
import com.mints.goodmoney.manager.TrackManager;
import com.mints.goodmoney.manager.YlhAdManager;
import com.mints.goodmoney.utils.LogUtil;
import com.qq.e.ads.rewardvideo.RewardVideoAD;
import com.qq.e.ads.rewardvideo.RewardVideoADListener;
import com.qq.e.comm.util.AdError;

/**
 * 优量汇视频
 */
public class YlhVideoAdManager extends BaseVideoAd {

    private static YlhVideoAdManager _inst;

    // 优量汇激励视频
    private RewardVideoAD rewardVideoAD;

    private VideoAdStatusListener videoAdStatusListener;

    private boolean isClickScreen = true; // 是否点击屏幕跳转广告

    public static YlhVideoAdManager getInstance() {
        if (_inst != null) {
            return _inst;
        } else {
            _inst = new YlhVideoAdManager();
            return _inst;
        }
    }

    @Override
    public void onDestroy() {
        rewardVideoAD = null;
    }

    /**
     * 加载优量汇激励视频
     */
    @Override
    public void loadAd(Activity activity, int curCoin, String carrierType, String extraId) {
        isClickScreen = true;

        String ylhPostId;
//        switch (carrierType) {
//            case Constant.CARRIER_VERSUS_VIDEO:// 每日任务视频
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_MAIN_POSTID;
//                break;
//            case Constant.CARRIER_OFFLINE_DOUBLE:// 离线收益翻倍
//            case Constant.CARRIER_SIGNIN_HOMEPAGE_CARD:// 签到翻倍
//            case Constant.CARRIER_WALK_BUBBLE:// 汽泡
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_MOREDIALOG_POSTID;
//                break;
//            case Constant.CARRIER_HOMEWATER:// 喝水
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_DRINK_POSTID;
//                break;
//            case Constant.CARRIER_CHALLENGE_TURN:// 大转盘
//            case Constant.CARRIER_DRAWCASH:// 提现
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_TURNABLE_POSTID;
//                break;
//            case Constant.CARRIER_CHALLENGE_CARD:// 刮刮乐
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_ERASE_POSTID;
//                break;
//            default:// 在线收益翻倍
//                ylhPostId = YlhAdManager.YLH_AD_VEDIO_MOREDIALOG_POSTID;
//                break;
//        }
        switch (carrierType) {
            case Constant.CARRIER_VERSUS_VIDEO:// 每日任务视频
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_MAIN_POSTID();
                break;
            case Constant.CARRIER_OFFLINE_DOUBLE:// 离线收益翻倍
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_OFFINELINE_POSTID();
                break;
            case Constant.CARRIER_SIGNIN_HOMEPAGE_CARD:// 签到翻倍
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_SIGN_POSTID();
                break;
            case Constant.CARRIER_WALK_BUBBLE:// 汽泡
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_MOREDIALOG_POSTID();
                break;
            case Constant.CARRIER_HOMEWATER:// 喝水
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_DRINK_POSTID();
                break;
            case Constant.CARRIER_CHALLENGE_TURN:// 大转盘
            case Constant.CARRIER_DRAWCASH:// 提现
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_TURNABLE_POSTID();
                break;
            case Constant.CARRIER_CHALLENGE_CARD:// 刮刮乐
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_ERASE_POSTID();
                break;
            case Constant.CARRIER_BLESSINGBAG_DOUBLE:// 福袋
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_BLESSINGBAG_POSTID();
                break;
            case Constant.CARRIER_HOMEVEDIO_DOUBLE:// 首页视频翻倍
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_HOMEVEDIO_POSTID();
                break;
            case Constant.CARRIER_SMALLHOMEVEDIO_DOUBLE:// 短视频翻倍
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_SMALLHOMEVEDIO_POSTID();
                break;
            case Constant.CARRIER_KUYINYUE_VEDIO:// 来电秀
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_KYLVEDIO_POSTID();
                break;
            default:// 在线收益翻倍
                ylhPostId = YlhAdManager.INSTANCE.getYLH_AD_VEDIO_MOREDIALOG_POSTID();
                break;
        }
//        ToastUtil.show(MintsApplication.getContext(), "ylh vedio:" + ylhPostId);
        if (rewardVideoAD != null) {
            rewardVideoAD = null;
        }


        rewardVideoAD = new RewardVideoAD(activity, ylhPostId, new RewardVideoADListener() {
            @Override
            public void onADLoad() {//广告加载成功，可在此回调后进行广告展示，此时广告过期时间确定，可通过RewardVideoAD.getExpireTimestamp()获取
                try {
                    if (!rewardVideoAD.hasShown()) {//广告展示检查2：当前广告数据还没有展示过
                        long delta = 1000;//建议给广告过期时间加个buffer，单位ms，这里demo采用1000ms的buffer
                        //广告展示检查3：展示广告前判断广告数据未过期
                        if (SystemClock.elapsedRealtime() < (rewardVideoAD.getExpireTimestamp() - delta)) {
                            rewardVideoAD.showAD();
                        } else {
//                            showToast("广告已过期，请再次请求广告后进行广告展示！");
                        }
                    } else {
//                        showToast("此条广告已经展示过，请再次请求广告后进行广告展示！");
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ONE, "999999", "Load Fail");

                    if (videoAdStatusListener != null) {
                        videoAdStatusListener.adFail();
                    }
                }
            }

            @Override
            public void onVideoCached() {//视频素材缓存成功，可在此回调后进行广告展示

            }

            @Override
            public void onADShow() {//激励视频广告页面展示，此后RewardVideoAD.hasShown()返回true
                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ZERO, "", "");

            }

            @Override
            public void onADExpose() {//激励视频广告曝光

            }

            @Override
            public void onReward() {//激励视频广告激励发放
//                if (activity != null) {
//                    ylhVideoAdPresenter.reportAddCoinMsg(activity, getAdMapVO(carrierType));
//                }
            }

            @Override
            public void onADClick() {//激励视频广告被点击
                if (AppConfig.needReportClickAdEvent) {
                    TrackManager.getInstance().reportClickAdEvent();
                }

                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_TWO, "", "");

                if (isClickScreen) {
                    // 防止重复
                    TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_FOUR, "", "");
                    isClickScreen = false;
                }
                if (videoAdStatusListener != null) {
                    videoAdStatusListener.adDownload();
                }
            }

            @Override
            public void onVideoComplete() {//广告视频素材播放完毕

            }

            @Override
            public void onADClose() {//激励视频广告被关闭
                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_THREE, "", "");

                TrackManager.getInstance().reportAddCoinMsg(activity, getAdMapVO(carrierType, Constant.AD_SOURCE_YLH, extraId, curCoin));

                if (videoAdStatusListener != null) {
                    videoAdStatusListener.adSuccess();
                }
            }

            @Override
            public void onError(AdError adError) {//广告流程出错，AdError中包含错误码和错误描述
                if (adError != null) {

                    LogUtil.d("YlhVideoAdManager", "onError  " + adError.getErrorCode() + adError.getErrorMsg());

                    // 0 成功 1失败 2点击 3-有效展示
                    TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ONE, String.valueOf(adError.getErrorCode()), adError.getErrorMsg());
                }
                if (videoAdStatusListener != null) {
                    videoAdStatusListener.adFail();
                }
            }
        });

        rewardVideoAD.loadAD();
    }

    public void setVideoAdStatusListener(VideoAdStatusListener videoAdStatusListener) {
        this.videoAdStatusListener = videoAdStatusListener;
    }
}
