package com.mints.goodmoney.ad.video.base

import android.app.Activity
import com.mints.goodmoney.common.Constant
import java.util.*

open class BaseVideoAd {
    /**
     * 激励视频请求接口封装
     */
    fun getAdMapVO(carrierType: String, adsource: String, extraId: String?, curCoin: Int): HashMap<String, Any> {
        val vo = HashMap<String, Any>()
        vo["carrierType"] = carrierType
        vo["adtype"] = Constant.ADTYPE_VEDIO
        vo["adsource"] = adsource
        var tempExtraId = ""
        if (extraId != null) {
            tempExtraId = extraId
        }

        when (carrierType) {
            Constant.CARRIER_VERSUS_VIDEO -> vo["coin"] = curCoin
            Constant.CARRIER_HOMEWATER -> vo["waterCoin"] = curCoin
            Constant.CARRIER_OFFLINE_DOUBLE -> vo["offline_income"] = curCoin
            Constant.CARRIER_CHALLENGE_TURN, Constant.CARRIER_CHALLENGE_CARD -> vo["turntableKey"] = tempExtraId
        }
        return vo
    }

    open fun loadAd(activity: Activity, curCoin: Int, carrierType: String, extraId: String?) {}

    open fun onDestroy() {}

}