package com.mints.goodmoney.call.business;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.provider.ContactsContract;
import android.provider.MediaStore;
import android.text.TextUtils;
import android.util.Log;
import android.widget.Toast;

import com.mints.goodmoney.utils.ToastUtil;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

/**
 * Ringtone设置来电秀
 * 作者：孟崔广
 */
public class RingtoneHelper {

    /**
     * 设置铃声为null
     *
     * @param context
     */
    public static void setNoRing(Context context) {
        if (context == null) {
            return;
        }
        RingtoneManager.setActualDefaultRingtoneUri(context, RingtoneManager.TYPE_RINGTONE, null);
        Toast.makeText(context, "已清除铃声！", Toast.LENGTH_SHORT).show();
    }

    /**
     * 设置系统铃声
     *
     * @param context
     * @param path
     */
    public static void setRing(Context context, String path) {
        if (context == null || TextUtils.isEmpty(path)) {
            return;
        }
        File sdFile = new File(path);
        ContentValues values = new ContentValues();
        values.put(MediaStore.MediaColumns.DATA, sdFile.getAbsolutePath());
        values.put(MediaStore.MediaColumns.TITLE, sdFile.getName());
        values.put(MediaStore.MediaColumns.MIME_TYPE, "audio/*");
        values.put(MediaStore.Audio.Media.IS_RINGTONE, true);
        values.put(MediaStore.Audio.Media.IS_NOTIFICATION, false);
        values.put(MediaStore.Audio.Media.IS_ALARM, false);
        values.put(MediaStore.Audio.Media.IS_MUSIC, false);

        Uri uri = MediaStore.Audio.Media.getContentUriForPath(sdFile.getAbsolutePath());
        if (uri == null) {
            return;
        }

        Uri newUri;
        String query = MediaStore.MediaColumns.DATA + "=\"" + sdFile.getAbsolutePath() + "\"";

        Cursor cursor = context.getContentResolver().query(uri, null, query, null, null);
        if (cursor != null) {
            if (cursor.moveToFirst()) {
                String id = cursor.getString(cursor.getColumnIndex(MediaStore.MediaColumns._ID));
                newUri = Uri.parse(uri.toString() + "/" + id);
            } else {
                newUri = context.getContentResolver().insert(uri, values);
            }
            cursor.close();
        } else {
            newUri = context.getContentResolver().insert(uri, values);
        }

        RingtoneManager.setActualDefaultRingtoneUri(context, RingtoneManager.TYPE_RINGTONE, newUri);
//        ToastUtil.show(context,"设置来电秀成功！");
    }
}
