package com.mints.goodmoney.manager

import android.app.Activity
import android.app.Dialog
import android.content.Context
import android.view.View
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.R
import com.mints.goodmoney.ui.widgets.dialog.CustomDialogAsApple
import com.mints.goodmoney.ui.widgets.dialog.DialogListener
import com.mints.goodmoney.ui.widgets.dialog.DialogUtils
import com.mints.goodmoney.utils.AppUtil
import com.mints.goodmoney.utils.LogUtil
import java.lang.ref.WeakReference

/**
 * APP试玩管理类
 */
object AppTryPlayManager {

    fun toTryPlay(pkg: String) {
        AppUtil.openThirdApp(MintsApplication.getContext(), pkg)
    }

    fun getTryPlayIsOK(pkg: String, useTime: Int): Boolean {
        val timePkgUsed = AppUtil.getTimePkgUsed(MintsApplication.getContext(), pkg)

        LogUtil.d("AppTryPlayManager -> " + timePkgUsed)
        return timePkgUsed >= useTime
    }

    /**
     * 打开应用使用记录授权弹框
     */
    fun openAppUsageStats(activity: Activity) {
        DialogUtils.showDialog(activity as Context, "提示", "该任务需要【应用使用记录】权限", "取消", "打开授权", object : DialogListener() {

            override fun onClick(dialog: Dialog?, v: View?) {
                dialog?.dismiss()

                when (v?.id) {
                    R.id.dialog_btn_right -> {
                        AppUtil.openUsageStats(activity as Context)
                    }
                }
            }

        })
    }

}