package com.mints.goodmoney.manager

import android.app.Activity
import android.content.Context
import android.text.TextUtils
import com.fendasz.moku.planet.entity.StyleConfig
import com.fendasz.moku.planet.exception.MokuException
import com.fendasz.moku.planet.helper.MokuHelper
import com.mints.goodmoney.R

/**
 * 描述：蘑菇星球
 * 作者：孟崔广
 */
object MokuManager {

    private const val APP_ID = "Y0jqdW3W"
    private const val APP_SECRET = "421ec06a6f1dbd75010f6f9e4d821cfe03e3a7a3"


    /**
     * 若gotoMoku前 校验了权限方法，可不用init
     */
    fun init(activity: Activity) {
        try {
            //初始化sdk
            MokuHelper.initSdk(activity)
        } catch (e: MokuException) {
            e.printStackTrace()
        }
    }

    fun initOaid(oaid: String) {
        try {
            //设置oaid
            MokuHelper.initOaid(oaid)
        } catch (e: MokuException) {
            e.printStackTrace()
        }
    }

    fun gotoMoku(context: Context) {
        val userId = UserManager.getInstance().userID
        if (TextUtils.isEmpty(userId)) {
            return
        }

        try {
            //启动sdk
            MokuHelper.startSdk(context, userId, APP_ID, APP_SECRET)

            val styleConfig = StyleConfig()
            //设置页面标题文字
            styleConfig.titleText = "截图任务"
            //设置标题栏颜色
            styleConfig.titleColor = context.getResources().getColor(R.color.color_FF9837)
            //设置状态栏颜色
            styleConfig.statusBarColor = context.getResources().getColor(R.color.color_FF9837)
            //设置标题栏返回键颜色
            styleConfig.titleBackColor = context.getResources().getColor(R.color.white)
            //设置标题文字颜色
            styleConfig.titleTextColor = context.getResources().getColor(R.color.white)
            //设置选项框背景颜色
            styleConfig.tabBackgroundColor = context.getResources().getColor(R.color.moku_gray_very_light)
            //设置选项框指示器颜色
            styleConfig.tabIndicatorColor = context.getResources().getColor(R.color.color_FF9837)
            //设置选项文字默认颜色
            styleConfig.tabTextColor = context.getResources().getColor(R.color.color_50FF9837)
            //设置选项文字选中颜色
            styleConfig.tabSelectedTextColor = context.getResources().getColor(R.color.color_FF9837)

            //设置主题样式
            MokuHelper.initStyleConfig(styleConfig)

            //跳转到蘑菇星球页面
            MokuHelper.startMokuMainActivity(context)
        } catch (e: MokuException) {
            e.printStackTrace()
        }
    }
}
