package com.mints.goodmoney.manager;

import android.content.Context;
import android.os.SystemClock;
import android.widget.Toast;

import com.chineseall.reader.lib.reader.callbacks.OnAdViewReceiver;
import com.mints.goodmoney.common.AppConfig;
import com.mints.goodmoney.common.Constant;
import com.mints.goodmoney.utils.LogUtil;
import com.mints.goodmoney.utils.ToastUtil;
import com.qq.e.ads.rewardvideo.RewardVideoAD;
import com.qq.e.ads.rewardvideo.RewardVideoADListener;
import com.qq.e.comm.util.AdError;

/**
 * 中文在线 听读 优量汇广告
 */
public class ReadYlhAd {

    private Context context;
    private RewardVideoAD rewardVideoAD;
    private boolean isClickScreen = true; // 是否点击屏幕跳转广告
    private OnVideoCloseCallBack callBack;

    public void loadVideoAd(Context context, OnAdViewReceiver receiver) {
        this.context = context;

        initVedioAD(context, receiver);
    }

    private void initVedioAD(final Context context, OnAdViewReceiver receiver) {
        rewardVideoAD = new RewardVideoAD(context, YlhAdManager.INSTANCE.getYLH_AD_VEDIO_READER_POSTID(), new RewardVideoADListener() {
            @Override
            public void onADLoad() {//广告加载成功，可在此回调后进行广告展示，此时广告过期时间确定，可通过RewardVideoAD.getExpireTimestamp()获取
                receiver.onReceive(true, null);
            }

            @Override
            public void onVideoCached() {//视频素材缓存成功，可在此回调后进行广告展示

            }

            @Override
            public void onADShow() {//激励视频广告页面展示，此后RewardVideoAD.hasShown()返回true
                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ZERO, "", "");

            }

            @Override
            public void onADExpose() {//激励视频广告曝光

            }

            @Override
            public void onReward() {//激励视频广告激励发放
//                if (activity != null) {
//                    ylhVideoAdPresenter.reportAddCoinMsg(activity, getAdMapVO(carrierType));
//                }
            }

            @Override
            public void onADClick() {//激励视频广告被点击
                if (AppConfig.needReportClickAdEvent) {
                    TrackManager.getInstance().reportClickAdEvent();
                }

                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_TWO, "", "");

                if (isClickScreen) {
                    // 防止重复
                    TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_FOUR, "", "");
                    isClickScreen = false;
                }
            }

            @Override
            public void onVideoComplete() {//广告视频素材播放完毕

            }

            @Override
            public void onADClose() {//激励视频广告被关闭
                if (callBack != null) {
                    callBack.onClose();
                }
                TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_THREE, "", "");
            }

            @Override
            public void onError(AdError adError) {//广告流程出错，AdError中包含错误码和错误描述
                receiver.onReceive(false, null);
                ToastUtil.show(context,"视频加载失败，请退出重试");
//                Toast.makeText(context, "视频播放错误", Toast.LENGTH_SHORT).show();
                if (adError != null) {

                    LogUtil.d("YlhVideoAdManager", "onError  " + adError.getErrorCode() + adError.getErrorMsg());

                    // 0 成功 1失败 2点击 3-有效展示
                    TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ONE, String.valueOf(adError.getErrorCode()), adError.getErrorMsg());
                }
            }
        });

        rewardVideoAD.loadAD();
    }

    public void showVideo(Context context,OnVideoCloseCallBack callBack) {
        this.callBack = callBack;
        try {
            if (!rewardVideoAD.hasShown()) {//广告展示检查2：当前广告数据还没有展示过
                long delta = 1000;//建议给广告过期时间加个buffer，单位ms，这里demo采用1000ms的buffer
                //广告展示检查3：展示广告前判断广告数据未过期
                if (SystemClock.elapsedRealtime() < (rewardVideoAD.getExpireTimestamp() - delta)) {
                    rewardVideoAD.showAD();
                } else {
//                            showToast("广告已过期，请再次请求广告后进行广告展示！");
                    ToastUtil.show(context,"视频加载失败，请退出重试");
                }
            } else {
//                        showToast("此条广告已经展示过，请再次请求广告后进行广告展示！");
                ToastUtil.show(context,"视频加载失败，请退出重试");
            }
        } catch (Exception e) {
            e.printStackTrace();
            TrackManager.getInstance().addCallImp(Constant.AD_SOURCE_YLH, Constant.EVENT_TYPE_ONE, "999999", "Load Fail");
        }
    }

    public interface OnVideoCloseCallBack {
        void onClose();
    }
}
