package com.mints.goodmoney.manager

import com.mints.goodmoney.ad.video.VideoAdingManager
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.mvp.model.UserTaskMsgBean
import com.mints.goodmoney.ui.fragment.MainFragment
import com.mints.goodmoney.utils.ForegroundOrBackground
import com.mints.goodmoney.utils.LogUtil

/**
 * 描述：用户广告视频数和权重
 * 作者：孟崔广
 */
object UserWeight {

    private val TAG = UserWeight::class.java.simpleName

    private val videoAdingManager by lazy { VideoAdingManager.getInstance(ForegroundOrBackground.getApp_activity()) }

    fun initAdWeight(data: UserTaskMsgBean) {
        AppConfig.isVideoSleep=data.vedioRules.isVedioSleep

        videoAdingManager.initAdWeight(data.vedioRules.csJ_VEDIO.rate,
                data.vedioRules.ylH_VEDIO.rate,
                data.vedioRules.sdhZ_VEDIO.rate,
                data.vedioRules.fL_VEDIO.rate,
                data.vedioRules.corAl_VIDEO.rate,
                data.vedioRules.csjfulL_VEDIO.rate,
                data.vedioRules.kS_VEDIO.rate,
                data.vedioRules.rtA_VEDIO.rate
        )
        LogUtil.d(TAG, "首页权重值：csjWeight:${data.vedioRules.csJ_VEDIO.rate}    " +
                "ylhWeight:${data.vedioRules.ylH_VEDIO.rate}    " +
                "sdhzWeight:${data.vedioRules.sdhZ_VEDIO.rate}    " +
                "csjFullWeight:${data.vedioRules.csjfulL_VEDIO.rate}    " +
                "shWeight:${data.vedioRules.corAl_VIDEO.rate}    " +
                "flWeight:${data.vedioRules.fL_VEDIO.rate}    " +
                "rtaWeight:${data.vedioRules.rtA_VEDIO.rate}    " +
                "ksWeight:${data.vedioRules.kS_VEDIO.rate}"
        )
        // 广告视频数
        AppConfig.csjVideoAdCount = data.vedioRules.csJ_VEDIO.surplus
        AppConfig.ylhAdCount = data.vedioRules.ylH_VEDIO.surplus
        AppConfig.wnVideoAdCount = data.vedioRules.sdhZ_VEDIO.surplus
        AppConfig.flVideoAdCount = data.vedioRules.fL_VEDIO.surplus
        AppConfig.shVideoAdCount = data.vedioRules.corAl_VIDEO.surplus
        AppConfig.ksVideoAdCount = data.vedioRules.kS_VEDIO.surplus
        AppConfig.rtaVideoAdCount = data.vedioRules.rtA_VEDIO.surplus
        AppConfig.csjFullVideoAdCount = data.vedioRules.csjfulL_VEDIO.surplus
        LogUtil.d(TAG, "首页视频数：csjCount:${AppConfig.csjVideoAdCount}    " +
                "ylhCount:${AppConfig.ylhAdCount}    " +
                "sdhzCount:${AppConfig.wnVideoAdCount}    " +
                "csjFullCount:${AppConfig.csjFullVideoAdCount}    " +
                "shCount:${AppConfig.shVideoAdCount}    " +
                "flCount:${AppConfig.flVideoAdCount}    " +
                "rtaCount:${AppConfig.rtaVideoAdCount}    " +
                "ksCount:${AppConfig.ksVideoAdCount}"
        )
    }
}