package com.mints.goodmoney.manager

import android.app.Application
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.widget.ImageView
import com.bumptech.glide.Glide
import com.bx.adsdk.AdSdk
import com.bx.adsdk.util.MaterialTm
import com.bytedance.sdk.openadsdk.TTAdConfig
import com.bytedance.sdk.openadsdk.TTAdConstant
import com.bytedance.sdk.openadsdk.TTAdSdk
import com.fendasz.moku.planet.exception.MokuException
import com.fendasz.moku.planet.helper.MokuHelper
import com.mints.goodmoney.BuildConfig
import com.mints.goodmoney.MintsApplication
import com.mints.goodmoney.utils.LogUtil
import com.qq.e.comm.managers.GDTADManager
import kotlinx.android.synthetic.main.activity_layout_xiaoman.*

/**
 * 描述：小满
 */
object XmManager {

    private const val ACCESSKEY = "hzq-az_rvkvdy"
    private const val SECRETKEY = "22FvHjUzvQ516214"

    private var placeMateId = ""
    private var materialId = ""

    fun initXm(application: Application) {
        try {
            //打开日志，上线之前记得关闭
            AdSdk.setDebug(BuildConfig.DEBUG)
            //初始化 需要在Applicaiton 中
            AdSdk.init(application, ACCESSKEY, SECRETKEY)
        } catch (e: Exception) {//这里应该是小满的异常
            e.printStackTrace()
        }
    }

    fun loadMater(placeid: String) {
        if (TextUtils.isEmpty(placeMateId)) {
            MaterialTm().loadMaterialData(UserManager.getInstance().userID, placeid, object : MaterialTm.Callback {
                //对应PlaceID会有对应的素材
                override fun onSuccess(imgUrl: String, placeMateId2: String, materialId2: String) {
                    placeMateId = placeMateId2
                    materialId = materialId2
                    AdSdk.exposure(UserManager.getInstance().userID, placeid, placeMateId, materialId);
                    LogUtil.d("******exposure*********${UserManager.getInstance().userID}******$placeMateId********$materialId****************$placeid**")
                }

                override fun onFailure(code: String, errmsg: String) {
                    LogUtil.d("$code$errmsg")
                }
            })
        } else {
            AdSdk.exposure(UserManager.getInstance().userID, placeid, placeMateId, materialId);
            LogUtil.d("******exposure*********${UserManager.getInstance().userID}******$placeMateId********$materialId****************$placeid**")
        }
    }


    /**
     * 入口点击上报
     * @param view
     */
    fun exprotClick(placeid: String) {
        if (!TextUtils.isEmpty(placeMateId)) {
            AdSdk.click(UserManager.getInstance().userID, placeid, materialId, materialId)
            LogUtil.d("******exprotClick*******${UserManager.getInstance().userID}*******$placeMateId********$materialId******$placeid")
        }
    }

}