package com.mints.goodmoney.manager

import android.app.Application
import android.os.Build
import android.text.TextUtils
import com.component.dly.xzzq_ywsdk.YwSDK.Companion.init
import com.component.dly.xzzq_ywsdk.YwSDK.Companion.setDebugMode
import com.mints.goodmoney.BuildConfig
import com.mints.goodmoney.MintsApplication

/**
 * 描述：鱼丸盒子游戏
 * 作者：孟崔广
 */
object YwhzManager {

    private const val APPID_DEBUG = "1725"
    private const val APPSECRET_DEBUG = "0yzizbqwyjt104gsdukmto53qclo9ljs"

    private const val APPID_RELEASE = "1726"
    private const val APPSECRET_RELEASE = "g4fuod79v6e7cw4liw91iwfm5qryvz1u"

    fun init(application: Application) {
        val userManager = UserManager.getInstance()
        var userID = userManager.userID
        if (!userManager.userIsLogin() || TextUtils.isEmpty(userID)) {
            // 用户id为空 或 未登录 = 游客
            userID = "0"
        }

        val appid: String
        val appSecret: String
        if (BuildConfig.DEBUG) {
            appid = APPID_DEBUG
            appSecret = APPSECRET_DEBUG
        } else {
            appid = APPID_RELEASE
            appSecret = APPSECRET_RELEASE
        }
        var oaid: String = ""
        if (Build.VERSION.SDK_INT > 28) {
            if (!TextUtils.isEmpty(MintsApplication.OAID)) {
                oaid = MintsApplication.OAID
            }
        }
        setDebugMode()
        init(application, appSecret, appid, userID, "1", oaid)
    }
}