package com.mints.goodmoney.mvp.model;

import java.io.Serializable;
import java.util.List;

public class TurnBean implements Serializable {

    /**
     * configs : [{"count":150,"type":"coin","key":"t1","index":0,"title":"150金币"},{"count":10,"type":"cash","key":"t2","index":1,"title":"现金10元"},{"count":200,"type":"coin","key":"t8","index":2,"title":"200金币"},{"count":100,"type":"coin","key":"t3","index":3,"title":"100金币"},{"count":300,"type":"coin","key":"t4","index":4,"title":"300金币"},{"count":250,"type":"coin","key":"t5","index":5,"title":"250金币"},{"count":350,"type":"coin","key":"t6","index":6,"title":"350金币"},{"count":40,"type":"cash","key":"t7","index":7,"title":"现金40元"}]
     * max : 30
     */

    private List<ConfigsBean> configs;
    private int max;
    private String titleMsg;
    private int surplus;
    private List<BottomsBean> bottoms;

    public List<ConfigsBean> getConfigs() {
        return configs;
    }

    public String getTitleMsg() {
        return titleMsg;
    }

    public void setTitleMsg(String titleMsg) {
        this.titleMsg = titleMsg;
    }

    public int getSurplus() {
        return surplus;
    }

    public void setSurplus(int surplus) {
        this.surplus = surplus;
    }

    public void setConfigs(List<ConfigsBean> configs) {
        this.configs = configs;
    }

    public int getMax() {
        return max;
    }

    public void setMax(int max) {
        this.max = max;
    }

    public List<BottomsBean> getBottoms() {
        return bottoms;
    }

    public void setBottoms(List<BottomsBean> bottoms) {
        this.bottoms = bottoms;
    }

    public class BottomsBean implements Serializable {
        /**
         * title : 高额赚
         * icon : https://mints-pkg.oss-cn-beijing.aliyuncs.com/pkg_goodmoney/img/readnews.png
         * toOtherKey : 1
         * rewardTitle : 抽奖 +1
         */

        private String title;
        private String icon;
        private String toOtherKey;
        private String rewardTitle;
        private ParamsBean params;

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }

        public String getIcon() {
            return icon;
        }

        public void setIcon(String icon) {
            this.icon = icon;
        }

        public String getToOtherKey() {
            return toOtherKey;
        }

        public void setToOtherKey(String toOtherKey) {
            this.toOtherKey = toOtherKey;
        }

        public String getRewardTitle() {
            return rewardTitle;
        }

        public void setRewardTitle(String rewardTitle) {
            this.rewardTitle = rewardTitle;
        }

        public class ParamsBean implements Serializable {
            private int max;
            private int complete;
            private int coin;

            public int getMax() {
                return max;
            }

            public int getComplete() {
                return complete;
            }

            public int getCoin() {
                return coin;
            }
        }
    }


    public class ConfigsBean implements Serializable {
        /**
         * count : 150
         * type : coin
         * key : t1
         * index : 0
         * title : 150金币
         */

        private int count;
        private String type;
        private String key;
        private int index;
        private String title;

        public int getCount() {
            return count;
        }

        public void setCount(int count) {
            this.count = count;
        }

        public String getType() {
            return type;
        }

        public void setType(String type) {
            this.type = type;
        }

        public String getKey() {
            return key;
        }

        public void setKey(String key) {
            this.key = key;
        }

        public int getIndex() {
            return index;
        }

        public void setIndex(int index) {
            this.index = index;
        }

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }
    }


}
