package com.mints.goodmoney.mvp.presenters

import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.MorningClockBean
import com.mints.goodmoney.mvp.views.FeedbackView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import java.util.*

class FeedbackPresenter : BasePresenter<FeedbackView>() {

    open fun feedback(type: String, content: String) {
        val vo = HashMap<String, Any>()
        vo["type"] = type
        vo["content"] = content
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.feedback(vo),
                        object : BaseSubscriber<BaseResponse<MorningClockBean>>() {
                            override fun onCompleted() {
                                if (isLinkView) return
                                view.hideLoading()
                            }

                            override fun onError(e: Throwable) {
                                if (isLinkView) return
                                view.hideLoading()
                                view.showToast(e.message)
                            }

                            override fun onNext(baseResponse: BaseResponse<MorningClockBean>) {
                                if (isLinkView) return
                                val code = baseResponse.status
                                val message = baseResponse.message

                                when (code) {
                                    200 -> view.feedbackSuc()
                                    else -> view.showToast(message)
                                }
                            }
                        })
    }
}