package com.mints.goodmoney.mvp.presenters

import com.google.gson.JsonObject
import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.KylBean
import com.mints.goodmoney.mvp.views.KylVideoView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import java.util.*

class KylVideoPresenter : BasePresenter<KylVideoView>() {

    fun getXfPageMsg(targetid:String,page: Int,pageCount: Int) {
        val vo = HashMap<String, Any>()
        vo["targetid"] = targetid
        vo["page"] = page
        vo["size"] = pageCount
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getXfPageMsg(vo),
                        object : BaseSubscriber<BaseResponse<KylBean>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                                if (isLinkView) return

                                view.getXfPageMsgFail()
                            }

                            override fun onNext(baseResponse: BaseResponse<KylBean>) {
                                if (isLinkView) return
                                val code = baseResponse.getStatus()
                                when (code) {
                                    200 -> {
                                        view.getXfPageMsgSuc(baseResponse.data)
                                    }
                                    else -> view.showToast(baseResponse.getMessage())
                                }
                            }
                        })
    }

    fun addReadSeconds(seconds: Int) {
        val vo = HashMap<String, Any>()
        vo["seconds"] = seconds
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.addReadSeconds(vo),
                        object : BaseSubscriber<BaseResponse<JsonObject>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                            }

                            override fun onNext(baseResponse: BaseResponse<JsonObject>) {
                                if (isLinkView) return
                                val code = baseResponse.getStatus()
                                val data = baseResponse.data
                                when (code) {
                                    200 -> {
                                        if (data != null) {
                                            val coin = data["coin"].asInt
//                                            view.readSecondsSuc(coin)
                                        }
                                    }
                                    else -> view.showToast(baseResponse.getMessage())
                                }
                            }
                        })
    }

}