package com.mints.goodmoney.mvp.presenters;

import com.mints.goodmoney.manager.AppHttpManager;
import com.mints.goodmoney.mvp.model.BaseResponse;
import com.mints.goodmoney.mvp.model.TaskCpdBean;
import com.mints.goodmoney.mvp.views.TaskCpdHistoryView;
import com.mints.library.net.neterror.BaseSubscriber;
import com.mints.library.net.neterror.Throwable;

public class TaskCpdHistoryPresenter extends BasePresenter<TaskCpdHistoryView> {

    /**
     * 获取首页喝水信息
     */
    public void getCpdUseAppModelMsg() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getCpdUseAppModelMsg(),
                        new BaseSubscriber<BaseResponse<TaskCpdBean>>() {
                            @Override
                            public void onCompleted() {
                                if (isLinkView()) return;

                                view.hideLoading();
                            }

                            @Override
                            public void onError(Throwable e) {
                                if (isLinkView()) return;

                                view.hideLoading();
                                view.showToast(e.getMessage());

                                view.getCpdUseAppModelMsgFail();
                            }

                            @Override
                            public void onNext(BaseResponse<TaskCpdBean> baseResponse) {
                                if (isLinkView()) return;

                                int code = baseResponse.getStatus();
                                String message = baseResponse.getMessage();
                                TaskCpdBean data = baseResponse.getData();
                                switch (code) {
                                    case 200://成功
                                        if (data != null) {
                                            view.getCpdUseAppModelMsgSuc(data);
                                        } else {
                                            view.getCpdUseAppModelMsgFail();
                                        }
                                        break;
                                    default:
                                        view.getCpdUseAppModelMsgFail();
                                        view.showToast(message);
                                        break;
                                }
                            }
                        });
    }

}
