package com.mints.goodmoney.mvp.presenters;

import android.app.Activity;
import android.text.TextUtils;

import com.google.gson.JsonObject;
import com.mints.goodmoney.MintsApplication;
import com.mints.goodmoney.common.AppConfig;
import com.mints.goodmoney.common.Constant;
import com.mints.goodmoney.common.DeviceInfo;
import com.mints.goodmoney.manager.AppHttpManager;
import com.mints.goodmoney.manager.SimulatorManager;
import com.mints.goodmoney.manager.UserWeight;
import com.mints.goodmoney.mvp.model.BaseResponse;
import com.mints.goodmoney.mvp.model.CommonParamBean;
import com.mints.goodmoney.mvp.model.UserTaskMsgBean;
import com.mints.goodmoney.utils.AccessibilityUtils;
import com.mints.goodmoney.utils.DeviceUuidFactory;
import com.mints.goodmoney.utils.rxutil.CommonRxTask;
import com.mints.goodmoney.utils.rxutil.RxjavaUtil;
import com.mints.library.net.neterror.BaseSubscriber;
import com.mints.library.net.neterror.Throwable;

import java.util.HashMap;

import rx.android.schedulers.AndroidSchedulers;

public class TrackPresenter extends BaseTrackPresenter {

    /**
     * 离线收益
     */
    public void offline() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.offline(),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                            }
                        });
    }

    /**
     * 广告事件
     * <p>
     * eventType-0 成功 1失败 2点击 3-有效展示
     */
    public void addCallImp(String adSource, String eventType, String errorcode, String errormsg) {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("adSource", adSource);
        vo.put("eventType", eventType);
        vo.put("errorCode", errorcode);
        vo.put("errorMsg", errormsg);

        AppHttpManager.getInstance(loanApplication)
                .call(loanService.addCallImp(vo),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                                if (TextUtils.equals(Constant.EVENT_TYPE_ONE, eventType)) {
                                    getAdWeight();
                                }
                            }
                        });
    }


    public void drawcashVideo() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.drawcashVideo(),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                            }
                        });
    }

    /**
     * 喜马拉雅听书时间
     */
    public void addCarrierTypeTime(int second) {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("time", second);
        vo.put("carrierType", Constant.CARRIER_XMLY_CHALLENGE);
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.addCarrierTypeTime(vo),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                            }
                        });
    }

    /**
     * 上报点击广告
     */
    public void reportClickAdEvent() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.reportClickAdEvent(),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                            }
                        });
    }

    /**
     * 每日任务是否刷新任务数
     */
    public void innerApp() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.innerApp(),
                        new BaseSubscriber<BaseResponse<Object>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<Object> baseResponse) {
                            }
                        });
    }


    public void getCommonHallBaseMsg() {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("param", "param");
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getCommonHallBaseMsg(vo),
                        new BaseSubscriber<BaseResponse<CommonParamBean>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<CommonParamBean> baseResponse) {
                                try {
                                    if (baseResponse.getStatus() == 200) {
                                        CommonParamBean data = baseResponse.getData();
                                        AppConfig.showAdFlag = data.isShowSomeodular();
                                    }
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                        });
    }

    /**
     * 首页是否显示微转
     */
    public void firstApiWithUid() {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("param", "param");
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.firstApiWithUid(vo),
                        new BaseSubscriber<BaseResponse<JsonObject>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<JsonObject> baseResponse) {
                                try {
                                    if (baseResponse.getStatus() == 200) {
                                        JsonObject data = baseResponse.getData();
                                        if (data != null) {
                                            if (data.get("mainFriendsStatus") != null) {
                                                AppConfig.mainFriendsStatus = data.get("mainFriendsStatus").getAsInt();
                                            }
                                            AppConfig.useAppCpdModelShow = data.get("useAppCpdModelShow").getAsBoolean();
                                        }
                                    }
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                        });
    }

    /**
     * 首页是否显示微转
     */
    public void saveInstallAppRecord(String pkg, String name, String icon) {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("pkg", pkg);
        vo.put("name", name);
        vo.put("icon", icon);
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.saveInstallAppRecord(vo),
                        new BaseSubscriber<BaseResponse<JsonObject>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<JsonObject> baseResponse) {
                            }
                        });
    }

    /**
     * 上送金币信息
     */
    public void reportAddCoinMsg(Activity activity, HashMap<String, Object> vo) {
        if (activity == null)
            return;

        loanApplication = (MintsApplication) activity.getApplication();
        loanService = loanApplication.getLoanService();

        subscription = loanService.reportAddCoinMsg(vo)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribeOn(loanApplication.defaultSubscribeScheduler())
                .subscribe(new BaseSubscriber<BaseResponse<Object>>() {
                    @Override
                    public void onCompleted() {
                    }

                    @Override
                    public void onError(Throwable e) {
                    }

                    @Override
                    public void onNext(BaseResponse<Object> baseResponse) {
                    }
                });
    }


    public void reportErrornterface(String url, String request) {
        HashMap<String, Object> vo = new HashMap<>();
        vo.put("url", url);
        vo.put("request", request);
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.reportErrornterface(vo),
                        new BaseSubscriber<BaseResponse<JsonObject>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<JsonObject> baseResponse) {
                            }
                        });
    }

    /**
     * 获取权重
     */
    public void getAdWeight() {
        AppHttpManager.getInstance(loanApplication)
                .call(loanService.vedioPlans(),
                        new BaseSubscriber<BaseResponse<UserTaskMsgBean>>() {
                            @Override
                            public void onCompleted() {
                            }

                            @Override
                            public void onError(Throwable e) {

                            }

                            @Override
                            public void onNext(BaseResponse<UserTaskMsgBean> baseResponse) {
                                UserWeight.INSTANCE.initAdWeight(baseResponse.getData());
                            }
                        });
    }

    public void riskinfo() {
        DeviceInfo deviceInfo = DeviceInfo.Companion.getInstance();
        HashMap<String, Object> vo = new HashMap<>();

        RxjavaUtil.executeRxTask(new CommonRxTask<String>("") {
            @Override
            public void doInIOThread() {
                setT(deviceInfo.getAppInfoMap());
            }

            @Override
            public void doInUIThread() {
                vo.put("androidid", deviceInfo.getAndroidId(null));
                vo.put("os", "android");
                vo.put("model", deviceInfo.getBrand() + " " + deviceInfo.getMobileModel());
                vo.put("uuid", new DeviceUuidFactory().getDeviceUuid());
                vo.put("osversion", deviceInfo.getOSVersion());
                vo.put("appversion", deviceInfo.getVersionName());
                vo.put("applist", getT());
                vo.put("eventid", Constant.RISK_EVENT_ID_TASK);
                vo.put("ischarge", deviceInfo.isCharging());
                vo.put("isusbdebug", deviceInfo.getGetUsbStatus());
                vo.put("iswifi", deviceInfo.getGetWifiConnected());
                vo.put("isroot", deviceInfo.isRoot());
                vo.put("isvpn", deviceInfo.isVPN());
                vo.put("memory", deviceInfo.getTotalMemory() + "+" + deviceInfo.getTotalStorage());
                vo.put("operator", deviceInfo.getOperator());
                vo.put("idfa", "");
                vo.put("imei", deviceInfo.getIMEI());
                vo.put("oaid", MintsApplication.OAID);
                vo.put("isSimulator", SimulatorManager.INSTANCE.isEmulator());
                vo.put("isAccessibility", AccessibilityUtils.isAccessibilityEnabled());

                RxjavaUtil.executeRxTask(new CommonRxTask<String>("") {
                    @Override
                    public void doInIOThread() {
                        setT(deviceInfo.getRunningApp());
                    }

                    @Override
                    public void doInUIThread() {
                        vo.put("appRunningPkgList", getT());
                        AppHttpManager.getInstance(loanApplication)
                                .call(loanService.riskinfo(vo),
                                        new BaseSubscriber<BaseResponse<Object>>() {
                                            @Override
                                            public void onCompleted() {
                                            }

                                            @Override
                                            public void onError(Throwable e) {
                                            }

                                            @Override
                                            public void onNext(BaseResponse<Object> baseResponse) {
                                            }
                                        });
                    }
                });
            }
        });
    }
}
