package com.mints.goodmoney.mvp.presenters

import com.google.gson.JsonObject
import com.mints.goodmoney.manager.AppHttpManager
import com.mints.goodmoney.mvp.model.BaseResponse
import com.mints.goodmoney.mvp.model.XmlyUnlockBean
import com.mints.goodmoney.mvp.views.XmlyPlayView
import com.mints.library.net.neterror.BaseSubscriber
import com.mints.library.net.neterror.Throwable
import java.util.*

class XmlyPlayPresenter : BasePresenter<XmlyPlayView>() {

    fun getXmlyUnlockMsg(uid: String, category: String, album: String) {
        val vo = HashMap<String, Any>()
        vo["uid"] = uid
        vo["category"] = category
        vo["album"] = album

        AppHttpManager.getInstance(loanApplication)
                .call(loanService.getXmlyUnlockMsg(vo),
                        object : BaseSubscriber<BaseResponse<XmlyUnlockBean>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                            }

                            override fun onNext(baseResponse: BaseResponse<XmlyUnlockBean>) {
                                if (isLinkView) return
                                val code = baseResponse.status
                                val data = baseResponse.data
                                when (code) {
                                    200 -> {
                                        if (data != null) {
                                            view.getXmlyUnlockMsgSuc(data.list)
                                        }
                                    }
                                    else -> view.showToast(baseResponse.message)
                                }
                            }
                        })
    }

    fun pushXmlyUnlockMsg(uid: String, category: String, album: String, entry: String) {
        val vo = HashMap<String, Any>()
        vo["uid"] = uid
        vo["category"] = category
        vo["album"] = album
        vo["entry"] = entry

        AppHttpManager.getInstance(loanApplication)
                .call(loanService.pushXmlyUnlockMsg(vo),
                        object : BaseSubscriber<BaseResponse<JsonObject>>() {
                            override fun onCompleted() {
                            }

                            override fun onError(e: Throwable) {
                            }

                            override fun onNext(baseResponse: BaseResponse<JsonObject>) {
                                if (isLinkView) return
                                val code = baseResponse.status
                                val data = baseResponse.data
                                when (code) {
                                    200 -> {
                                        if (data != null) {
                                            view.pushXmlyUnlockMsgSuc()
                                        }
                                    }
                                    else -> view.showToast(baseResponse.message)
                                }
                            }
                        })
    }

}