package com.mints.goodmoney.ui.activitys

import android.os.Bundle
import android.view.View
import com.mints.goodmoney.R
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.ad.express.TTPreLoadCarrierExpressManager
import com.mints.goodmoney.manager.TtCsjAdManager
import com.mints.goodmoney.mvp.model.MealBean
import com.mints.goodmoney.mvp.presenters.FoodSubsidyPresenter
import com.mints.goodmoney.mvp.views.FoodSubsidyView
import com.mints.goodmoney.ui.activitys.base.BaseActivity
import com.mints.goodmoney.ui.widgets.MealView
import com.mints.goodmoney.ui.widgets.StepView
import kotlinx.android.synthetic.main.activity_food_subsidy.*

/**
 * 描述：饭补
 * 作者：孟崔广
 * 时间：2020/10/13 11:55
 */
class FoodSubsidyActivity : BaseActivity(), View.OnClickListener, FoodSubsidyView, StepView.StepViewListener, MealView.MealViewListener {

    private val foodSubsidyPresenter by lazy { FoodSubsidyPresenter() }

    private var curCoin = 0//点击的汽泡金币
    private var buttonCoin = 0//点击的汽泡金币

    private var isCanClickVideo = false

    override fun getContentViewLayoutID() = R.layout.activity_food_subsidy

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        foodSubsidyPresenter.attachView(this)

        initListener()
    }

    override fun onResume() {
        super.onResume()

        initExpress()
        foodSubsidyPresenter.getMealMsg()
    }

    override fun onDestroy() {
        super.onDestroy()

        svWalk?.destoryAnim()
        flSubsidykAd?.removeAllViews()
        foodSubsidyPresenter.detachView()
    }

    private fun initListener() {
        ivWalkBack.setOnClickListener(this)
        svWalk.setMealViewListener(this)
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.ivWalkBack -> {
                finish()
            }
        }
    }

    override fun clickWater(water: Int, waterCoin: String) {
        if (water == 0) {
            val bundle = Bundle()
            bundle.putInt(Constant.MAIN_CUR_COIN, buttonCoin)
            bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_EATMEAL)
            readyGo(AwardActivity::class.java, bundle)

        } else {
            if (isCanClickVideo) {
                val bundle = Bundle()
                bundle.putInt(Constant.MAIN_CUR_COIN, curCoin)
                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_EATMEAL_SUBSIDY)
                readyGo(AwardActivity::class.java, bundle)
                svWalk.setCancelAnim(water)
            } else {
                val bundle = Bundle()
                bundle.putString(Constant.MAIN_CARRIER_TYPE, Constant.CARRIER_EATMEAL_SUBSIDY_NOT)
                readyGo(AwardActivity::class.java, bundle)
            }
        }

        // 预加载信息流
        TTPreLoadCarrierExpressManager.getInstance().loadTtFrameLayout(TtCsjAdManager.TT_AD_NATIVEEXPRESS_EAT)
    }


    /**
     * 初始化信息iyc
     */
    private fun initExpress() {
        try {
            if (TTPreLoadCarrierExpressManager.getInstance().ttFrameLayout != null) {
                if (flSubsidykAd != null) {
                    flSubsidykAd.removeAllViews()
                    flSubsidykAd.addView(TTPreLoadCarrierExpressManager.getInstance().ttFrameLayout)
                }
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    override fun getFoodSubsidySuc(data: MealBean) {

        svWalk.setThreeBtnGone()
        curCoin = data.vedioCoin
        buttonCoin = data.buttonCoin

        this.isCanClickVideo = data.isCanClickVedio

        for (i in 0 until data.vedioCount) {
            svWalk.setWaterTextviewLayout(i + 1, 0)
        }

        // 是否可领取奖励
        if (data.isCanClickButton) {
            svWalk.setTvDrinkBtnEnable()
        } else {
            svWalk.setTvDrinkBtnNone()
        }
        svWalk.setTvDrinkBtnText(data.buttonMsg)
    }
}