package com.mints.goodmoney.ui.activitys

import android.view.KeyEvent
import android.view.View
import android.view.ViewGroup
import com.bytedance.sdk.openadsdk.AdSlot
import com.bytedance.sdk.openadsdk.TTAdNative
import com.bytedance.sdk.openadsdk.TTSplashAd
import com.mints.goodmoney.R
import com.mints.goodmoney.manager.TTNativeExpressManager
import com.mints.goodmoney.manager.TtCsjAdManager
import com.mints.goodmoney.ui.activitys.base.BaseActivity
import com.mints.library.net.netstatus.NetUtils

private val TAG = SplashCsjADActivity::class.java.simpleName

/**
 * 后台返回时每次都展示 快手广告
 */
class SplashCsjADActivity : BaseActivity() {
    private var container: ViewGroup? = null
    private var mIsPaused = false
    var canJump = false

    private var mTTAdNative: TTAdNative? = null

    override fun getContentViewLayoutID(): Int {
        return R.layout.activity_splash_ylh
    }

    override fun initViewsAndEvents() {
        if (!NetUtils.isNetworkConnected(context)) {
            finish()
        } else {
            try {
                container = findViewById<View>(R.id.splash_container) as ViewGroup
                //step2:创建TTAdNative对象
                val ttNativeExpressManager = TTNativeExpressManager()
                mTTAdNative = ttNativeExpressManager.initTTAd(false)

                loadSplashAd()
            } catch (e: Exception) {
                readyGoOtherActivity()
            }
        }

    }

    override fun isApplyKitKatTranslucency(): Boolean {
        return false
    }

    private fun loadSplashAd() {
        //step3:创建开屏广告请求参数AdSlot
        var adSlot: AdSlot? = AdSlot.Builder()
                .setCodeId(TtCsjAdManager.TT_AD_SPLASH)
                .setImageAcceptedSize(1080, 1920)
                .build()

        mTTAdNative!!.loadSplashAd(adSlot, object : TTAdNative.SplashAdListener {
            override fun onError(p0: Int, p1: String?) {
                readyGoOtherActivity()
            }

            override fun onTimeout() {
                readyGoOtherActivity()
            }

            override fun onSplashAdLoad(ad: TTSplashAd?) {
                if (ad == null) {
                    readyGoOtherActivity()
                    return
                }

                val splashView = ad.splashView
                if (container != null && !isFinishing) {
                    container!!.removeAllViews()
                    //把SplashView 添加到ViewGroup中,注意开屏广告view：width >=70%屏幕宽；height >=50%屏幕高
                    container!!.addView(splashView)
                    //设置不开启开屏广告倒计时功能以及不显示跳过按钮,如果这么设置，您需要自定义倒计时逻辑
                    //ad.setNotAllowSdkCountdown();
                } else {
                    readyGoOtherActivity()
                }

                ad.setSplashInteractionListener(object : TTSplashAd.AdInteractionListener {
                    override fun onAdClicked(p0: View?, p1: Int) {
                    }

                    override fun onAdShow(p0: View?, p1: Int) {
                    }

                    override fun onAdSkip() {
                        readyGoOtherActivity()
                    }

                    override fun onAdTimeOver() {
                        readyGoOtherActivity()
                    }

                })

            }

        }, 3000)

    }

    /**
     * 设置一个变量来控制当前开屏页面是否可以跳转，当开屏广告为普链类广告时，点击会打开一个广告落地页，此时开发者还不能打开自己的App主页。当从广告落地页返回以后，
     * 才可以跳转到开发者自己的App主页；当开屏广告是App类广告时只会下载App。
     */
    private operator fun next() {
        if (mIsPaused) {
            canJump = true
        } else {
            readyGoOtherActivity()
        }
    }

    override fun onPause() {
        super.onPause()
        mIsPaused = true

    }

    override fun onResume() {
        super.onResume()
        mIsPaused = false

        if (canJump) {
            next()
        }
    }

    /**
     * 开屏页一定要禁止用户对返回按钮的控制，否则将可能导致用户手动退出了App而广告无法正常曝光和计费
     */
    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        return if (keyCode == KeyEvent.KEYCODE_BACK) {
            true
        } else super.onKeyDown(keyCode, event)
    }

    private fun readyGoOtherActivity() {
        finish()
    }

}