package com.mints.goodmoney.ui.activitys

import android.graphics.Point
import android.os.Bundle
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import androidx.fragment.app.FragmentTransaction
import com.bx.adsdk.CampaignCallback
import com.bx.adsdk.CampaignFragment
import com.bytedance.sdk.openadsdk.*
import com.google.gson.Gson
import com.mints.goodmoney.R
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.manager.UserManager
import com.mints.goodmoney.manager.YlhAdManager
import com.mints.goodmoney.mvp.model.JsBridgeBean
import com.mints.goodmoney.ui.activitys.base.BaseActivity
import com.qq.e.ads.banner2.UnifiedBannerView
import com.qq.e.ads.nativ.express2.NativeExpressAD2
import com.qq.e.ads.nativ.express2.NativeExpressADData2
import com.qq.e.ads.rewardvideo.RewardVideoAD
import com.qq.e.ads.rewardvideo.RewardVideoADListener
import com.qq.e.comm.util.AdError
import kotlinx.android.synthetic.main.header_layout.*

class XiaomanActivity : BaseActivity(), View.OnClickListener {

    private var placeId = ""//
    private var activityTitle = ""//
    private var isPlaySuccess = false
    private var rewardVideoAD: RewardVideoAD? = null
    private var unifiedBannerView: UnifiedBannerView? = null
    private val TAG = "XiaomanActivity"
    private val campaignFragment by lazy { CampaignFragment.newInstance(System.currentTimeMillis().toString()) }

    private var mttRewardVideoAd: TTRewardVideoAd? = null

    private var mTTAd: TTNativeExpressAd? = null
    private var mNativeExpressADData2: NativeExpressADData2? = null
    private var mNativeExpressAD2: NativeExpressAD2? = null

    private val bannerContainer: ViewGroup? = null


    override fun getContentViewLayoutID(): Int {
        return R.layout.activity_layout_xiaoman
    }

    override fun getBundleExtras(extras: Bundle?) {
        super.getBundleExtras(extras)
        extras?.let {
            placeId = it.getString(Constant.ACTIVITY_ID, "")
            activityTitle = it.getString(Constant.ACTIVITY_TITLE, "")
        }
    }

    override fun initViewsAndEvents() {
        iv_left_icon.visibility = View.VISIBLE
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back)
        tv_title.text = activityTitle
        initListener()
        /**
         * CampaignFragment.newInstance("这里为userId")
         * 为方便测试,demo中采用时间戳来标识用户唯一id
         * 媒体对接时注意替换
         */
        campaignFragment.setPlaceId(placeId)
        campaignFragment.setCallback(object : CampaignCallback() {
            override fun showAd(s: String) {//2.2.9.1//调用激励视频
                super.showAd(s)
                /**
                 * 这里需要根据adType来判断展示广告的平台 1-穿山甲 2-广点通 3-快手
                 * pid: 对应平台的代码位
                 *
                 * 这里采用广点通的例子,媒体注意替换
                 */
                val bean: JsBridgeBean = Gson().fromJson(s, JsBridgeBean::class.java)
                if (bean.adType.equals("1")) {
                    loadBytedanceAd(campaignFragment, bean)
                } else if (bean.adType.equals("2")) {
                    loadGDTRewardVideo(campaignFragment, bean)
                }
            }

            /**
             * Banner广告
             * @param params
             */
            override fun showBanner(params: String) {
                //2.2.9.3 展示Banner类型广告
                Log.d(TAG, "showBanner: $params")
//                Toast.makeText(this@XiaomanActivity, params, Toast.LENGTH_LONG).show()
                val bean: JsBridgeBean = Gson().fromJson(params, JsBridgeBean::class.java)
                if (TextUtils.isEmpty(bean.pid)) {
                    return
                }
                when (bean.adType) {
//                    "4" -> loadCSJBannerAd(fragment, bean)//穿山甲激励视频
//                    "5" -> loadGDTBannerAd(fragment, bean)//广点通激励视频
//                    "13" -> loadCSJBannerAd(fragment, bean)//穿山甲横幅
//                    "14" -> loadGDTNativeExpressAd(fragment, bean)//广点通横幅
                }
            }

            override fun hideBanner(params: String) {
                super.hideBanner(params)
                bannerContainer?.removeAllViews()
                if (unifiedBannerView != null) {
                    unifiedBannerView?.destroy()
                    unifiedBannerView = null
                }
            }
        })

        val transaction: FragmentTransaction = supportFragmentManager.beginTransaction()
        transaction.add(R.id.frame_layout, campaignFragment)
        transaction.commitAllowingStateLoss()
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
    }

    /**
     * banner2.0规定banner宽高比应该为6.4:1 , 开发者可自行设置符合规定宽高比的具体宽度和高度值
     *
     * @return
     */
    private fun getUnifiedBannerLayoutParams(): FrameLayout.LayoutParams? {
        val screenSize = Point()
        windowManager.defaultDisplay.getSize(screenSize)
        return FrameLayout.LayoutParams(screenSize.x, Math.round(screenSize.x / 6.4f))
    }

    override fun onDestroy() {
        super.onDestroy()
        if (unifiedBannerView != null) {
            unifiedBannerView?.destroy()
        }
        if (mTTAd != null) {
            //调用destroy()方法释放
            mTTAd!!.destroy()
        }
        destroyAd()
    }

    /**
     * 加载广点通横幅广告
     * @param fragment
     * @param bean
     */
//    private fun loadGDTNativeExpressAd(fragment: CampaignFragment, bean: JsBridgeBean) {
//
//        // 创建广告
//        mNativeExpressAD2 = NativeExpressAD2(applicationContext, "", object : NativeExpressAD2.AdLoadListener {
//            override fun onLoadSuccess(list: List<NativeExpressADData2>) {
//                fragment.setBannerLoad(bean.requestId)
//                gdtBannerRenderAd(fragment, bean, list)
//            }
//
//            override fun onNoAD(adError: AdError) {
//                fragment.setBannerError(bean.requestId)
//            }
//        })
//        mNativeExpressAD2?.setAdSize(390, 0) // 单位dp
//        mNativeExpressAD2?.loadAd(1)
//        destroyAd()
//        bannerContainer?.removeAllViews()
//    }


    /**
     * 渲染广告
     * @param adDataList
     */
//    private fun gdtBannerRenderAd(fragment: CampaignFragment, bean: JsBridgeBean, adDataList: List<NativeExpressADData2>) {
//        if (adDataList.size > 0) {
//            bannerContainer?.removeAllViews()
//            mNativeExpressADData2 = adDataList[0]
//            mNativeExpressADData2?.setAdEventListener(object : AdEventListener {
//                override fun onClick() {
//                    Log.i(TAG, "onClick: $mNativeExpressADData2")
//                    fragment.setBannerClick(bean.requestId)
//                }
//
//                override fun onExposed() {
//                    Log.i(TAG, "onImpression: $mNativeExpressADData2")
//                    fragment.setBannerExpose(bean.requestId)
//                }
//
//                override fun onRenderSuccess() {
//                    Log.i(TAG, "onRenderSuccess: $mNativeExpressADData2")
//                    bannerContainer?.removeAllViews()
//                    if (mNativeExpressADData2?.getAdView() != null) {
//                        bannerContainer?.addView(mNativeExpressADData2?.getAdView())
//                    }
//                }
//
//                override fun onRenderFail() {
//                    Log.i(TAG, "onRenderFail: $mNativeExpressADData2")
//                    fragment.setBannerError(bean.requestId)
//                }
//
//                override fun onAdClosed() {
//                    Log.i(TAG, "onAdClosed: $mNativeExpressADData2")
//                    fragment.setBannerClose(bean.requestId)
//                    bannerContainer?.removeAllViews()
//                    mNativeExpressADData2?.destroy()
//                }
//            })
//            mNativeExpressADData2!!.render()
//        }
//    }


    /**
     * 加载广点通
     * @param fragment
     * @param bean
     */
    private fun loadGDTRewardVideo(fragment: CampaignFragment, bean: JsBridgeBean) {
        rewardVideoAD = RewardVideoAD(applicationContext, YlhAdManager.YLH_AD_APPID, bean.pid, object : RewardVideoADListener {
            override fun onADLoad() {
                Log.e(TAG, "onADLoad")
                rewardVideoAD?.showAD()
                isPlaySuccess = false
                fragment.setVideoLoad(bean.requestId)
            }

            override fun onVideoCached() {
                Log.e(TAG, "onVideoCached")
            }

            override fun onADShow() {
                Log.e(TAG, "onADShow")
            }

            override fun onADExpose() {
                Log.e(TAG, "onADExpose")
                fragment.setVideoExposeComplete(bean.requestId)
            }

            override fun onReward() {
                Log.e(TAG, "onReward")
                isPlaySuccess = true
            }

            override fun onADClick() {
                Log.e(TAG, "onADClick")
                fragment.setVideoClickComplete(bean.requestId)
            }

            override fun onVideoComplete() {
                Log.e(TAG, "onVideoComplete")
            }

            override fun onADClose() {
                Log.e(TAG, "onADClose")
                if (isPlaySuccess) {
                    fragment.setVideoClose(bean.requestId)
                } else {
                    fragment.setVideoSkip(bean.requestId)
                }
            }

            override fun onError(adError: AdError) {
                Log.e(TAG, "onError:--->" + adError.errorMsg)
                fragment.setVideoError(bean.requestId)
            }
        })
        rewardVideoAD?.loadAD()
    }

    /**
     * 加载广点通banner广告
     * @param fragment
     * @param bean
     */
//    private fun loadGDTBannerAd(fragment: CampaignFragment?, bean: JsBridgeBean) {
//        var pid = bean.pid
//        // TODO: 2021/1/8 demo中代码位写死, 媒体注意替换
//        pid = ""
//        //广点通底部Banner
//        unifiedBannerView = UnifiedBannerView(this@XiaomanActivity, pid, object : UnifiedBannerADListener {
//            override fun onNoAD(adError: AdError) {
//                Log.e(TAG, "广告加载失败: onNoAD")
//                fragment?.setBannerError(bean.requestId)
//            }
//
//            override fun onADReceive() {
//                Log.e(TAG, "广告加载成功回调: onADReceive")
//                fragment?.setBannerLoad(bean.requestId)
//            }
//
//            override fun onADExposure() {
//                Log.e(TAG, "广告曝光: onADExposure")//2.2.7.1 曝光上报,在活动入口渲染完成后必须调用
//                fragment?.setBannerExpose(bean.requestId)
//            }
//
//            override fun onADClosed() {
//                Log.e(TAG, "广告关闭: onADClosed")
//                fragment?.setBannerClose(bean.requestId)
//            }
//
//            override fun onADClicked() {
//                Log.e(TAG, "广告点击: onADClicked")//2.2.7.2 点击上报，活动入口点击时进行调用必须调用
//                fragment?.setBannerClick(bean.requestId)
//            }
//
//            override fun onADLeftApplication() {
//                Log.e(TAG, "广告点击离开 APP : onADLeftApplication")
//            }
//
//            override fun onADOpenOverlay() {
//                Log.e(TAG, "广告打开浮层: onADOpenOverlay")
//            }
//
//            override fun onADCloseOverlay() {
//                Log.e(TAG, "广告浮层关闭: onADCloseOverlay")
//            }
//        })
//        bannerContainer?.addView(unifiedBannerView, getUnifiedBannerLayoutParams())
//        unifiedBannerView!!.loadAD()
//    }

    /**
     * 加载穿山甲视频广告
     * @param fragment
     * @param bean
     */
    private fun loadBytedanceAd(fragment: CampaignFragment, bean: JsBridgeBean) {//2.2.9.2 广告数据上报//底部穿山甲banner
        val adSlot = AdSlot.Builder()
                .setCodeId(bean.pid) // 这里要替换成 bean.pid
                .setAdCount(1) //个性化模板广告需要设置期望个性化模板广告的大小,单位dp,激励视频场景，只要设置的值大于0即可
                .setExpressViewAcceptedSize(500f, 500f)
                .setImageAcceptedSize(1080, 1920) //非必传参数，仅奖励发放服务端回调时需要使用
                .setUserID(UserManager.getInstance().userID) //非必传参数，仅奖励发放服务端回调时需要使用
                .setMediaExtra("media_extra")
                .build()
        val mTTAdNative = TTAdSdk.getAdManager().createAdNative(applicationContext)
        mTTAdNative.loadRewardVideoAd(adSlot, object : TTAdNative.RewardVideoAdListener {
            override fun onError(code: Int, message: String) {
                Log.d(TAG, "穿山甲-加载失败$code====$message")
                fragment.setVideoError(bean.requestId)
            }

            //视频广告加载后的视频文件资源缓存到本地的回调
            override fun onRewardVideoCached() {}

            //视频广告素材加载到，如title,视频url等，不包括视频文件
            override fun onRewardVideoAdLoad(ad: TTRewardVideoAd) {
                fragment.setVideoLoad(bean.requestId)
                Log.d(TAG, "穿山甲-加载成功")
                isPlaySuccess = false
                mttRewardVideoAd = ad
                bindBytedanceVideoAdListener(fragment, bean, mttRewardVideoAd!!)
                mttRewardVideoAd?.showRewardVideoAd(this@XiaomanActivity)
            }
        })
    }

    /**
     * 穿山甲激励视频绑定监听事件
     * @param fragment
     * @param bean
     */
    private fun bindBytedanceVideoAdListener(fragment: CampaignFragment, bean: JsBridgeBean, ad: TTRewardVideoAd) {
        ad.setRewardAdInteractionListener(object : TTRewardVideoAd.RewardAdInteractionListener {
            override fun onAdShow() {
                Log.d(TAG, "穿山甲-曝光")
                fragment.setVideoExposeComplete(bean.requestId)
            }

            override fun onAdVideoBarClick() {
                Log.d(TAG, "穿山甲-点击")
                fragment.setVideoClickComplete(bean.requestId)
            }

            override fun onAdClose() {
                if (isPlaySuccess) {
                    fragment.setVideoClose(bean.requestId)
                } else {
                    fragment.setVideoSkip(bean.requestId)
                }
            }

            override fun onVideoComplete() {}
            override fun onVideoError() {
                Log.d(TAG, "穿山甲-视频失败")
                fragment.setVideoError(bean.requestId)
            }

            override fun onRewardVerify(rewardVerify: Boolean, rewardAmount: Int, rewardName: String, errorCode: Int, errorMsg: String) {
                Log.d(TAG, "穿山甲-验证")
                isPlaySuccess = rewardVerify
            }

            override fun onSkippedVideo() {}
        })
    }

    /**
     * 加载穿山甲banner广告，穿山甲激励视频
     * @param fragment
     * @param bean
     */
//    private fun loadCSJBannerAd(fragment: CampaignFragment, bean: JsBridgeBean) {
//        val mTTAdNative = TTAdSdk.getAdManager().createAdNative(applicationContext)//2.2.9.3穿山甲底部banner
//        var pid = bean.pid
//        // 在demo中,为了方便测试,写死.媒体在实际应用中注意替换
//        pid = "946012845"
//        val adSlot = AdSlot.Builder()
//                .setCodeId(pid) //广告位id
//                .setSupportDeepLink(true)
//                .setAdCount(1) //请求广告数量为1到3条
//                .setExpressViewAcceptedSize(600f, 0f) //期望模板广告view的size,单位dp
//                .build()
//        mTTAdNative.loadBannerExpressAd(adSlot, object : TTAdNative.NativeExpressAdListener {
//            //请求失败回调
//            override fun onError(code: Int, message: String) {
//                fragment.setBannerError(bean.requestId)
//            }
//
//            //请求成功回调
//            override fun onNativeExpressAdLoad(ads: List<TTNativeExpressAd>) {
//                if (ads == null || ads.size == 0) {
//                    return
//                }
//                fragment.setBannerLoad(bean.requestId)
//                mTTAd = ads[0]
//                mTTAd?.setSlideIntervalTime(30 * 1000) //设置轮播间隔 ms,不调用则不进行轮播展示
//                bindBytedanceBannerAdListener(fragment, bean, mTTAd!!)
//                mTTAd?.render() //调用render开始渲染广告
//            }
//        })
//    }

    /**
     * 绑定穿山甲banner类型监听
     * @param fragment
     * @param bean
     * @param ad
     */
//    private fun bindBytedanceBannerAdListener(fragment: CampaignFragment, bean: JsBridgeBean, ad: TTNativeExpressAd) {//绑定穿山甲banner监听
//        ad.setExpressInteractionListener(object : TTNativeExpressAd.ExpressAdInteractionListener {
//            override fun onAdClicked(view: View, type: Int) {
//                fragment.setBannerClick(bean.requestId)
//            }
//
//            override fun onAdShow(view: View, type: Int) {}
//            override fun onRenderFail(view: View, msg: String, code: Int) {
//                fragment.setBannerError(bean.requestId)
//            }
//
//            override fun onRenderSuccess(view: View, width: Float, height: Float) {
//                fragment.setBannerExpose(bean.requestId)
//                //在渲染成功回调时展示广告，提升体验
//                bannerContainer?.removeAllViews()
//                bannerContainer?.addView(view)
//            }
//        })
//
//        //dislike设置
//        bindDislike(fragment, bean, ad)
//        if (ad.interactionType != TTAdConstant.INTERACTION_TYPE_DOWNLOAD) {
//            return
//        }
//    }

    /**
     * 穿山甲banner广告关闭事件绑定
     * @param fragment
     * @param bean
     * @param ad
     */
//    private fun bindDislike(fragment: CampaignFragment, bean: JsBridgeBean, ad: TTNativeExpressAd) {
//
//        //使用默认个性化模板中默认dislike弹出样式
//        ad.setDislikeCallback(this@XiaomanActivity, object : TTAdDislike.DislikeInteractionCallback {
//            override fun onSelected(position: Int, value: String) {
//                //用户选择不喜欢原因后，移除广告展示
//                fragment.setBannerClose(bean.requestId)
//                bannerContainer?.removeAllViews()
//            }
//
//            override fun onCancel() {}
//            override fun onRefuse() {}
//        })
//    }

    override fun onBackPressed() {
        if (campaignFragment != null) {
            campaignFragment.backButtonClick(object : CampaignFragment.CallBack {
                override fun onSuccess(jsonData: String) {
                    super@XiaomanActivity.onBackPressed()
                }

                override fun onFailure(code: String, errmsg: String) {}
            })
        } else {
            super.onBackPressed()
        }
    }

    /**
     * 释放前一个 NativeExpressADData2 的资源
     */
    private fun destroyAd() {
        if (mNativeExpressADData2 != null) {
            Log.d(TAG, "destroyAD")
            mNativeExpressADData2?.destroy()
        }
    }

    override fun isApplyKitKatTranslucency(): Boolean {
        return false
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.iv_left_icon -> {
                campaignFragment?.backButtonClick(object : CampaignFragment.CallBack {
                    override fun onSuccess(p0: String?) {
                        super@XiaomanActivity.onBackPressed()
                    }

                    override fun onFailure(p0: String?, p1: String?) {
                        finish()
                    }
                })
            }
        }
    }
}