package com.mints.goodmoney.ui.adapter;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.FrameLayout;
import android.widget.ImageView;

import com.mints.goodmoney.R;
import com.mints.goodmoney.ad.banner.BannerManager;
import com.mints.goodmoney.manager.TtCsjAdManager;
import com.mints.goodmoney.mvp.model.RotationChartBean;
import com.mints.goodmoney.utils.LogUtil;
import com.mints.library.utils.GlideUtils;


/**
 * 描述：轮播图Adapter
 * 作者：孟崔广
 * 时间：2018/5/13 16:36
 * 邮箱：mengcg@xiaojinqb.cn
 */
public class AdBannerAdapter extends BannerBaseAdapter<RotationChartBean.ListBean> {

    private Context mContext;
    private int mCurrentPostion = 0;

//    private FrameLayout frameLayout;


    public AdBannerAdapter(Context context) {
        super(context);
        this.mContext = context;
//        frameLayout = new FrameLayout(context);
    }

    public void setAdPosition(int position) {
        mCurrentPostion = position;
    }

    @Override
    protected int getLayoutResID() {
        return R.layout.item_banner_ad;
    }

    @Override
    protected void convert(View convertView, RotationChartBean.ListBean listBean, int currentPostion) {
        FrameLayout container = getView(R.id.ad_container);

        // mCurrentPostion = 1
//        if (currentPostion == 0) {
//            BannerManager.INSTANCE.getTtBanner(TtCsjAdManager.TT_AD_BANNER_MY, frameLayout);
//        }

        if (currentPostion == mCurrentPostion && mCurrentPostion != -1) {
            BannerManager.INSTANCE.getTtBanner(TtCsjAdManager.TT_AD_BANNER_MY, container);
//            final ViewParent customParent = frameLayout.getParent();
//            if (customParent != this) {
//                if (customParent != null) {
//                    ((ViewGroup) customParent).removeAllViews();
//                }
//                container.addView(frameLayout);
//            }
        } else {
            ImageView iv = getView(R.id.iv_banner_ad);
            iv.setVisibility(View.VISIBLE);
            GlideUtils.loadImageView(mContext, listBean.getImgUrl(), iv);

            iv.setOnClickListener(v -> {
                if (mOnPageClickListener != null) {
                    mOnPageClickListener.onPageClick(currentPostion);
                }
            });
        }
    }

    private OnPageClickListener mOnPageClickListener;

    public void setOnPageClickListener(OnPageClickListener onPageClickListener) {
        mOnPageClickListener = onPageClickListener;
    }

    public interface OnPageClickListener {
        void onPageClick(int position);
    }
}
