package com.mints.goodmoney.ui.adapter;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;

import com.mints.goodmoney.R;
import com.mints.goodmoney.common.Constant;
import com.mints.goodmoney.manager.BxmManager;
import com.mints.goodmoney.manager.UserManager;
import com.mints.goodmoney.manager.XmManager;
import com.mints.goodmoney.mvp.model.BannerBean;
import com.mints.library.utils.GlideUtils;

import java.util.List;

/**
 * 描述：我的界面
 * 作者：孟崔广
 * 时间：2019/10/28 19:21
 * 邮箱：mengcga@163.com
 */
public class GvMyAdapter extends BaseAdapter {

    private List<BannerBean.ListBean> orders;
    private Activity activity;

    private int mCurrentIndex;
    private int mPageSize;

    public GvMyAdapter(Activity activity, List<BannerBean.ListBean> orders, int currentIndex, int pageSize) {
        this.orders = orders;
        this.activity = activity;
        this.mCurrentIndex = currentIndex;
        this.mPageSize = pageSize;
    }

    @Override
    public int getCount() {
//        return orders == null ? 0 : orders.size();
        return orders.size() > (mCurrentIndex + 1) * mPageSize ? mPageSize : (orders.size() - mCurrentIndex * mPageSize);

    }

    @Override
    public Object getItem(int position) {
//        return orders.get(position);
        return orders.get(position + mCurrentIndex * mPageSize);
    }

    @Override
    public long getItemId(int position) {
//        return position;
        return position + mCurrentIndex * mPageSize;
    }

    @SuppressLint("WrongViewCast")
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        ViewHolder viewHolder;

        if (convertView == null) {
            LayoutInflater inflater = LayoutInflater.from(activity);
            convertView = inflater.inflate(R.layout.item_list_my, null);
            viewHolder = new ViewHolder();

            viewHolder.fl_my_icon = convertView.findViewById(R.id.fl_my_icon);
            viewHolder.ic_my_icon = convertView.findViewById(R.id.ic_my_icon);
            viewHolder.tv_my_title = convertView.findViewById(R.id.tv_my_title);

            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }

        /**
         * 在给View绑定显示的数据时，计算正确的position = position + curIndex * pageSize
         */
        int pos = position + mCurrentIndex * mPageSize;

        BannerBean.ListBean data = orders.get(pos);
        if (data != null) {
            GlideUtils.loadImageView(activity, data.getImgUrl(), viewHolder.ic_my_icon);
            viewHolder.tv_my_title.setText(data.getTitle());

            if (TextUtils.equals(data.getToUrl(), Constant.HOT_ACTIVITY_BXM) && UserManager.getInstance().userIsLogin()) {
                BxmManager.INSTANCE.loadButtonAd(activity, viewHolder.fl_my_icon);
            }
        }
        return convertView;
    }

    class ViewHolder {
        public ImageView ic_my_icon;
        public FrameLayout fl_my_icon;
        public TextView tv_my_title;
    }
}

