package com.mints.goodmoney.ui.adapter;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AccelerateDecelerateInterpolator;
import android.widget.BaseAdapter;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;

import com.daimajia.androidanimations.library.Techniques;
import com.daimajia.androidanimations.library.YoYo;
import com.mints.goodmoney.R;
import com.mints.goodmoney.common.Constant;
import com.mints.goodmoney.manager.BxmManager;
import com.mints.goodmoney.manager.UserManager;
import com.mints.goodmoney.mvp.model.BannerBean;
import com.mints.goodmoney.mvp.model.TurnBean;
import com.mints.goodmoney.utils.rxutil.CommonRxTask;
import com.mints.goodmoney.utils.rxutil.RxjavaUtil;
import com.mints.library.utils.GlideUtils;

import java.util.List;
import java.util.Timer;

public class TurnTableAdapter extends BaseAdapter {

    private List<TurnBean.BottomsBean> orders;
    private Activity activity;
    private YoYo.AnimationComposer rope;

    public TurnTableAdapter(Activity activity, List<TurnBean.BottomsBean> orders) {
        this.orders = orders;
        this.activity = activity;
        rope = YoYo.with(Techniques.Pulse).duration(1000).repeat(0);
    }

    @Override
    public int getCount() {
        return orders == null ? 0 : orders.size();
    }

    @Override
    public Object getItem(int position) {
        return orders.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @SuppressLint("WrongViewCast")
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        ViewHolder viewHolder;

        if (convertView == null) {
            LayoutInflater inflater = LayoutInflater.from(activity);
            convertView = inflater.inflate(R.layout.item_list_turn, null);
            viewHolder = new ViewHolder();

            viewHolder.ic_turn_icon = convertView.findViewById(R.id.ic_turn_icon);
            viewHolder.tv_turn_top = convertView.findViewById(R.id.tv_turn_top);
            viewHolder.tv_turn_bottom = convertView.findViewById(R.id.tv_turn_bottom);

            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }


        TurnBean.BottomsBean data = orders.get(position);
        if (data != null) {
            GlideUtils.loadImageView(activity, data.getIcon(), viewHolder.ic_turn_icon);
            viewHolder.tv_turn_top.setText(TextUtils.isEmpty(data.getRewardTitle()) ? "" : data.getRewardTitle());
            viewHolder.tv_turn_bottom.setText(data.getTitle());

            if (!TextUtils.isEmpty(data.getRewardTitle())) {
                RxjavaUtil.executeRxTask(new CommonRxTask<String>("") {
                    @Override
                    public void doInIOThread() {
                        try {
                            Thread.sleep(500);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }

                    @Override
                    public void doInUIThread() {
                        rope.playOn(viewHolder.ic_turn_icon);
                    }
                });
            }
        }
        return convertView;
    }

    class ViewHolder {
        public ImageView ic_turn_icon;
        public TextView tv_turn_top;
        public TextView tv_turn_bottom;
    }
}

