package com.mints.goodmoney.ui.fragment

import android.view.View
import androidx.fragment.app.Fragment
import androidx.viewpager.widget.ViewPager
import com.fly.scenemodule.util.GsonUtils
import com.mints.goodmoney.R
import com.mints.goodmoney.common.AppConfig
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.ui.adapter.MessageFragAdapter
import com.mints.goodmoney.ui.fragment.base.LazyLoadBaseFragment
import com.mints.goodmoney.utils.LogUtil
import com.ximalaya.ting.android.opensdk.datatrasfer.CommonRequest
import com.ximalaya.ting.android.opensdk.datatrasfer.IDataCallBack
import com.ximalaya.ting.android.opensdk.model.category.CategoryList
import kotlinx.android.synthetic.main.fragment_main_xmly.*
import java.util.*
import kotlin.collections.ArrayList
import kotlin.concurrent.schedule

/**
 * 描述：喜马拉雅
 * 作者：孟崔广
 */
class XmlyFragment : LazyLoadBaseFragment() {

    override fun getContentViewLayoutID() = R.layout.fragment_main_xmly

    override fun initViewsAndEvents() {

    }

    override fun onFragmentFirstVisible() {
        super.onFragmentFirstVisible()
        loadData()
    }

    private fun loadData() {
        showLoading("加载中...")

        // 获取分类数据
        val vo = hashMapOf<String, String>()
        CommonRequest.getCategories(vo, object : IDataCallBack<CategoryList> {
            override fun onSuccess(p0: CategoryList?) {
                initViewAndData(p0)
            }

            override fun onError(p0: Int, p1: String?) {
                LogUtil.e(p1)
                hideLoading()
            }

        })
    }

    private fun initViewAndData(categoryList: CategoryList?) {
//        hideLoading()

        categoryList?.let {
            val tabs: MutableList<String> = ArrayList()
            val fragments: MutableList<Fragment> = ArrayList()
            var tempPageSize = 18
            if (it.categories.size < 18) {
                tempPageSize = it.categories.size
            }

            for (i in 0 until tempPageSize) {
                tabs.add(it.categories[i].categoryName)
                fragments.add(XmlyPageFragment(it.categories[i].id))
            }

            Timer().schedule(1000) {
                activity?.runOnUiThread {
                    hideLoading()
                    xtFragmentXmly.visibility = View.VISIBLE
                }
            }

            xtFragmentXmly.overScrollMode = ViewPager.OVER_SCROLL_NEVER
            vpFragmentXmly.offscreenPageLimit = tabs.size + 3
            val adapter = MessageFragAdapter(childFragmentManager, fragments, tabs)
            vpFragmentXmly.adapter = adapter
            xtFragmentXmly.setxTabDisplayNum(tabs.size)
            xtFragmentXmly.setupWithViewPager(vpFragmentXmly)

        }
    }
}