package com.mints.goodmoney.ui.widgets.dialog

import android.content.Context
import android.text.Spanned
import java.lang.ref.WeakReference

object DialogUtils {

    /**
     *
     * 普通弹框
     */
    fun showDialog(ctx: Context, title: String, content: String, leftStr: String, rightStr: String, dialogListener: DialogListener) {
        val weakReference = WeakReference<Context>(ctx)
        val cdaa = CustomDialogAsApple(weakReference.get(), dialogListener)
        cdaa.let {
            it.setTitle(title)
            it.setContent(content)
            it.setLeft(leftStr)
            it.setRight(rightStr)
            it.show()
        }
        dialogListener.setDialog(cdaa)
        cdaa.setDialogListener(dialogListener)
    }

    fun showDialog(ctx: Context, title: String, content: Spanned, leftStr: String, rightStr: String, dialogListener: DialogListener) {
        val weakReference = WeakReference<Context>(ctx)
        val cdaa = CustomDialogAsApple(weakReference.get(), dialogListener)
        cdaa.let {
            it.setTitle(title)
            it.setContent(content)
            it.setLeft(leftStr)
            it.setRight(rightStr)
            it.show()
        }
        dialogListener.setDialog(cdaa)
        cdaa.setDialogListener(dialogListener)
    }

    /**
     *
     * 分红奖励页弹框
     */
    fun showBonusDialog(ctx: Context, title: String, content: String, btnStr: String, dialogListener: DialogListener) {
        val weakReference = WeakReference<Context>(ctx)
        val bonusDialog = BonusDialog(weakReference.get()!!, dialogListener)
        bonusDialog.let {
            it.setTitle(title)
            it.setContent(content)
            it.setBtnStr(btnStr)
            it.show()
        }
        dialogListener.setDialog(bonusDialog)
    }

    /**
     *
     * 权限请求弹框
     */
    fun showPowerDialog(ctx: Context, dialogListener: DialogListener) {
        val weakReference = WeakReference<Context>(ctx)
        val bonusDialog = PowerDialog(weakReference.get()!!, dialogListener)
        bonusDialog.show()
        dialogListener.setDialog(bonusDialog)
    }
}