package com.mints.goodmoney.ui.widgets.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.KeyEvent
import android.view.WindowManager
import android.widget.Button
import android.widget.ImageView
import com.mints.goodmoney.R
import com.mints.goodmoney.ui.widgets.ClearEditText

/**
 * 提示弹框
 */
class JDTintDialog(context: Context, listener: DialogListener) :
        Dialog(context, R.style.dialog) {
    private val lp: WindowManager.LayoutParams
    private val etLoginMobile: ClearEditText
    private val btnBindMobile: Button
    private val ivClose: ImageView

    init {
        setContentView(R.layout.dialog_jd_bind_mobile)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }

        // 查找View
        etLoginMobile = findViewById(R.id.etLoginMobile)
        btnBindMobile = findViewById(R.id.btnBindMobile)
        ivClose = findViewById(R.id.ivClose)
        ivClose.setOnClickListener(listener)
        etLoginMobile.setOnClickListener(listener)
        btnBindMobile.setOnClickListener(listener)
    }

    fun getMobileNum(): String {
        return etLoginMobile.text.toString().trim()
    }
}