package com.mints.goodmoney.ui.widgets.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.WindowManager
import android.widget.ImageView
import android.widget.TextView
import com.mints.goodmoney.R
import com.mints.library.utils.GlideUtils

/**
 * 提示弹框
 */
class TaskCpdDialog(context: Context, listener: DialogListener) :
        Dialog(context, R.style.dialog) {
    private val lp: WindowManager.LayoutParams
    private val tvTitle: TextView
    private val tvText1: TextView
    private val tvText2: TextView
    private val tvInfo: TextView
    private val ivAvatar: ImageView
    private val textView: TextView

    init {
        setContentView(R.layout.dialog_task)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
//        setCancelable(false)
//        setCanceledOnTouchOutside(false)
//        setOnKeyListener { _, i, _ ->
//            i == KeyEvent.KEYCODE_BACK
//        }

        // 查找View
        tvTitle = findViewById(R.id.dialog_tv_title)
        tvText1 = findViewById(R.id.dialog_tv_text1)
        tvText2 = findViewById(R.id.dialog_tv_text2)
        ivAvatar = findViewById(R.id.dialog_iv_avatar)
        tvInfo = findViewById(R.id.dialog_tv_info)
        textView = findViewById(R.id.dialog_btn_download)

        textView.setOnClickListener(listener)
    }

    fun setData(title: String?, description: String?, icon: String?, seconds: Int, coin: Int) {
        if (seconds > 0) {
            tvText1.text = "下载并试玩$seconds" + "秒"
        } else {
            tvText1.text = "下载领取金币"
        }
        tvText2.text = "+$coin" + "金币"
        tvTitle.text = title
        GlideUtils.loadImageView(context, icon, ivAvatar)
        tvInfo.text = description
    }

}