package com.mints.goodmoney.utils;

import android.content.Context;
import android.view.accessibility.AccessibilityManager;

import com.mints.goodmoney.MintsApplication;

/**
 * 无障碍服务
 */
public class AccessibilityUtils {

    /**
     * 判断用户是否开启无障碍服务
     *
     * @return 0-未开启无障碍功能
     * @throws RuntimeException
     */
    public static int isAccessibilityEnabled() {
        try {
            // 检查AccessibilityService是否开启
            AccessibilityManager am = (AccessibilityManager) MintsApplication.getContext().getSystemService(Context.ACCESSIBILITY_SERVICE);
            boolean isAccessibilityEnabled_flag = am.isEnabled();
            return isAccessibilityEnabled_flag ? 1 : 0;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return 0;
//        boolean isExploreByTouchEnabled_flag = false;
//
//        // 检查无障碍服务是否以语音播报的方式开启
//        isExploreByTouchEnabled_flag = isScreenReaderActive(context);
//
//        return (isAccessibilityEnabled_flag && isExploreByTouchEnabled_flag);
    }

}
