package com.mints.goodmoney.utils

import android.app.Activity
import android.content.Intent
import android.net.Uri
import com.mints.goodmoney.MintsApplication

object QQJumpUtil {

    private const val QQCustomerNum = "2504421942"

    /**
     * 跳转QQ聊天界面
     */
    fun jumpQQ(activity: Activity) {
        try {
            //第二种方式：可以跳转到添加好友，如果qq号是好友了，直接聊天
            val url = "mqqwpa://im/chat?chat_type=wpa&uin=$QQCustomerNum" //uin是发送过去的qq号码
//            val url = "mqq://im/chat?chat_type=wap&uin=$QQCustomerNum&version=1&src_type=web" //uin是发送过去的qq号码

            activity.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse(url)))
        } catch (e: Exception) {
            // 未安装手Q或安装的版本不支持
            ToastUtil.show(MintsApplication.getContext(), "您还没有安装QQ，请先安装软件")
        }
    }

    /****************
     *
     * 发起添加群流程。群号：好赚钱官方1群(971534757) 的 key 为： kf-7yVcbY2iKltXVDOtVCPez1zCBNcl4
     * 调用 joinQQGroup(kf-7yVcbY2iKltXVDOtVCPez1zCBNcl4) 即可发起手Q客户端申请加群 好赚钱官方1群(971534757)
     *
     * @param key 由官网生成的key
     * @return 返回true表示呼起手Q成功，返回false表示呼起失败
     ******************/
    fun jumpQQGroup(url: String, activity: Activity) {
        val intent = Intent()
        intent.data = Uri.parse(url)
        // 此Flag可根据具体产品需要自定义，如设置，则在加群界面按返回，返回手Q主界面，不设置，按返回会返回到呼起产品界面    //intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
        try {
            activity.startActivity(intent)
        } catch (e: java.lang.Exception) {
            // 未安装手Q或安装的版本不支持
            ToastUtil.show(MintsApplication.getContext(), "您还没有安装QQ，请先安装软件")
        }
    }
}