package com.mints.goodmoney.service;

import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.IBinder;

public class AppInstallService extends Service {

    public static final String APP_INSTALL_ACTION = "com.mints.goodmoney.updateInstallPkg";

    BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
        public void onReceive(Context param1Context, Intent param1Intent) {
            if (param1Intent == null)
                return;
            String str = param1Intent.getData().toString();
            if (str.length() <= 8)
                return;
            str = str.substring(8);
            if (!str.equals(AppInstallService.this.getPackageName())) {
                try {
                    Intent intent = new Intent();
                    intent.setAction(APP_INSTALL_ACTION);
                    intent.putExtra("pkg", str);
                    AppInstallService.this.sendBroadcast(intent);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    };

    private void initReceiver() {
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("android.intent.action.PACKAGE_ADDED");
//        intentFilter.addAction("android.intent.action.PACKAGE_REPLACED");
//        intentFilter.addAction("android.intent.action.PACKAGE_REMOVED");
        intentFilter.addDataScheme("package");
        registerReceiver(this.broadcastReceiver, intentFilter);
    }

    public IBinder onBind(Intent paramIntent) {
        return null;
    }

    public void onCreate() {
        super.onCreate();
        initReceiver();
    }

    public void onDestroy() {
        super.onDestroy();
        try {
            unregisterReceiver(this.broadcastReceiver);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public int onStartCommand(Intent paramIntent, int paramInt1, int paramInt2) {
        return super.onStartCommand(paramIntent, paramInt1, paramInt2);
    }
}
